// ********************************************************************
// This is a part of the PDF Xpansion SDK 13.
// Copyright (C) 2002-2018 soft Xpansion
// All rights reserved.
//
// This source code is only intended as a supplement to the PDF Xpansion SDK 
// and related electronic documentation provided with the libraries.
// ********************************************************************

#pragma once
#include "../basic.h"

namespace SX
{
	namespace PDF
	{
		interface IDocPart;
		interface IPartDocument;
		interface IDocument;

		interface IDocParts
		{
			virtual sx_uint get_RecordLevel() const = 0;
			virtual void set_RecordLevel(sx_uint level) = 0;

			virtual IStr* GetLevelName(sx_uint level) const = 0;
			virtual void SetLevelName(sx_uint level, sx_str name) = 0;
			virtual IDocPart* GetRoot(sx_bool bCreate = false) = 0;
		};

		interface IDocPart : public IRefObject
		{
			virtual sx_uint get_Level() const = 0;
			virtual IDocPart* get_Parent() = 0;
			virtual IAssociatedFiles* get_AssocFiles() = 0;

			virtual IPage* get_StartPage() const = 0;
			virtual void set_StartPage(IPage* pPage) = 0;
			virtual IPage* get_EndPage() const = 0;
			virtual void set_EndPage(IPage* pPage) = 0;

			virtual sx_uint get_SubParts() const = 0;
			virtual IDocPart* GetSubPart(sx_uint uIndex) const = 0;
			virtual IDocPart* AddSubPart() = 0;
			virtual IDocPart* InsertSubPart(sx_uint uTo) = 0;
			virtual void RemoveSubPart(sx_uint uIndex) = 0;
			virtual void RemoveAllSubParts() = 0;

			virtual IRawProps* GetPrivateProps(sx_bool bCreate = false) = 0;
			virtual IPartDocument* CreatePartDocument(IDocument *pDoc) = 0;
		};

		interface IPartDocument : public IBaseDocument
		{
			virtual IDocument* GetRefDoc() = 0;
			virtual IDocPart* GetPart() = 0;
		};

	} // namespace PDF
} // namespace SX
