// ********************************************************************
// This is a part of the PDF Xpansion SDK 13.
// Copyright (C) 2002-2018 soft Xpansion
// All rights reserved.
//
// This source code is only intended as a supplement to the PDF Xpansion SDK 
// and related electronic documentation provided with the libraries.
// ********************************************************************

#pragma once
#include "../basic.h"

namespace SX
{
	namespace PDF
	{
		interface IDocReq : public IRefObject
		{
			virtual IStr* get_Type() const = 0;
			// min version
			virtual IStr* get_FormatVersion() const = 0;
			virtual void set_FormatVersion(sx_str szVersion) = 0;
			virtual IStr* GetExtFormatVersion(sx_str szDevName) const = 0;
			virtual sx_uint GetExtFormatLevel(sx_str szDevName) const = 0;
			virtual void SetExtFormat(sx_str szDevName, sx_str szBaseVersion, sx_uint uLevel) = 0;
			// when this requirement cannot be met
			virtual sx_uint get_Penalty() const = 0;
			virtual void set_Penalty(sx_uint val) = 0;
			// alternative requirements
			virtual IRawProps* GetAltReq(sx_bool bReset = false, sx_bool bDict = false) = 0;
			// encryption template
			virtual IRawProps* GetEncTemplate(sx_bool bReset = false) = 0;
			// signature template
			virtual IRawProps* GetSignTemplate(sx_bool bReset = false) = 0;
		};

		interface IDocReqs
		{
			virtual sx_uint get_Count() const = 0;

			virtual IDocReq* Item(sx_uint ind) = 0;
			virtual sx_uint Find(sx_str sType) = 0;
			virtual IDocReq* Add(sx_str sType) = 0;
			virtual void Remove(sx_uint ind) = 0;
		};

	} // namespace PDF
} // namespace SX
