// ********************************************************************
// This is a part of the PDF Xpansion SDK 13.
// Copyright (C) 2002-2018 soft Xpansion
// All rights reserved.
//
// This source code is only intended as a supplement to the PDF Xpansion SDK 
// and related electronic documentation provided with the libraries.
// ********************************************************************

#pragma once
#include "../basic.h"

#include "../basic.h"

namespace SX
{
	namespace PDF
	{
		object_type obj_type_embedded_file = 0x1A;

		//////////////////////////////////////////////////////////////////////////
		// file reference (embedded file stream) 
		interface IFileRef : public IRefObject
		{
			//////////////////////////////////////////////////////////////////////////
			// properties
			virtual IStr*   get_Description() const       = 0;
			virtual void    set_Description(sx_str sDesc) = 0;
			virtual IStr*   get_FullName() const          = 0;
			virtual void    set_FullName(sx_str sName)    = 0;
			virtual IStr*   get_MIMEType() const          = 0;
			virtual void    set_MIMEType(sx_str sType)    = 0;
			virtual sx_uint get_Size() const              = 0;
			virtual IStr*   get_Association() const       = 0;

			//////////////////////////////////////////////////////////////////////////
			// methods
			virtual sx_time GetMDate() const  = 0;
			virtual sx_time GetCDate() const  = 0;
			virtual IStr*   GetURL() const      = 0;
			virtual void    SetURL(sx_str sURL) = 0;
			virtual void    GetData(ISequentialStream *pData) const = 0;
			virtual void    SetData(ISequentialStream *pData, sx_bool bFlateComp = true) = 0;
		};

		//////////////////////////////////////////////////////////////////////////
		interface IEmbeddedFiles
		{
			//////////////////////////////////////////////////////////////////////////
			// properties
			virtual sx_uint get_Count() const = 0;

			//////////////////////////////////////////////////////////////////////////
			// methods
			virtual IStr*     GetID(sx_uint uIndex) = 0;
			virtual IFileRef* Get(sx_str sID)       = 0;
			virtual IFileRef* Add(sx_str sID)       = 0;
			virtual void      Remove(sx_str sID)    = 0;
		};

		//////////////////////////////////////////////////////////////////////////
		interface IAssociatedFiles
		{
			//////////////////////////////////////////////////////////////////////////
			// properties
			virtual sx_uint get_Count() const = 0;

			//////////////////////////////////////////////////////////////////////////
			// methods
			virtual IFileRef* Get(sx_uint id) = 0;
			virtual void Add(IFileRef* pFile, sx_str sAssoc) = 0;
			virtual void Remove(sx_uint id) = 0;
		};

	} // namespace PDF
} // namespace SX
