// ********************************************************************
// This is a part of the PDF Xpansion SDK 13.
// Copyright (C) 2002-2018 soft Xpansion
// All rights reserved.
//
// This source code is only intended as a supplement to the PDF Xpansion SDK 
// and related electronic documentation provided with the libraries.
// ********************************************************************

#pragma once
#include "../basic.h"
namespace SX
{
	namespace PDF
	{
		object_type obj_type_pdf_outline = 0x12;
		interface IDest;
		interface IPDFActions;

		//////////////////////////////////////////////////////////////////////////
		// outline item 
		interface IOutlineItem : public IRefObject
		{
			//////////////////////////////////////////////////////////////////////////
			// properties
			virtual IStr*  get_Title() const             = 0;
			virtual void   set_Title(sx_str sTitle)      = 0;
			virtual IStr*  get_NamedDest() const         = 0;
			virtual void   set_NamedDest(sx_str sTitle)  = 0;
			virtual IDest* get_Dest() const              = 0;

			//////////////////////////////////////////////////////////////////////////
			// methods
			virtual IOutlineItem* Parent()                       = 0;
			virtual IOutlineItem* FirstChild()                   = 0;
			virtual IOutlineItem* NextChild(IOutlineItem* pPrev) = 0;
			virtual IOutlineItem* InsertChild(sx_str sTitle, IOutlineItem* pBeforeChild = nullptr)     = 0;
			virtual void          RemoveChild(IOutlineItem* pItem)                                     = 0;
			virtual void          Move(IOutlineItem* pNewParent, IOutlineItem* pBeforeChild = nullptr) = 0;
			virtual IDest*        ResetDest(sx_bool clear = false) = 0;
			virtual IPDFActions* GetActions() const = 0;
		};
	} // namespace PDF
} // namespace SX
