// ********************************************************************
// This is a part of the PDF Xpansion SDK 13.
// Copyright (C) 2002-2018 soft Xpansion
// All rights reserved.
//
// This source code is only intended as a supplement to the PDF Xpansion SDK 
// and related electronic documentation provided with the libraries.
// ********************************************************************

#pragma once
namespace SX
{
	namespace PDF
	{
		enum pdfa
		{
			pdfa_none =  0,
			pdfa_1a = 0x1a,
			pdfa_1b = 0x1b,
			pdfa_2a = 0x2a,
			pdfa_2b = 0x2b,
			pdfa_2u = 0x2c,
			pdfa_3a = 0x3a,
			pdfa_3b = 0x3b,
			pdfa_3u = 0x3c
		};

		enum pdfa_mess
		{
			pdfa_mess_info				= 0x1000,
			pdfa_mess_warn				= 0x2000,
			pdfa_mess_error				= 0x4000,
			pdfa_mess_cat				= 0xF000,

			pdfa_mess_begin				= 1,
			pdfa_mess_end				= 2,
			pdfa_mess_security			= 3,
			pdfa_mess_version			= 4,
			pdfa_mess_doc_id			= 5,
			pdfa_mess_doc_actions			= 6,
			pdfa_mess_optional_content		= 7,
			pdfa_mess_need_appearances		= 8,
			pdfa_mess_field_actions			= 9,
			pdfa_mess_annot_appearance		= 10,
			pdfa_mess_portfolio			= 11,
			pdfa_mess_emb_files			= 12,
			pdfa_mess_xfa				= 13,
			pdfa_mess_mark_info			= 14,
			pdfa_mess_java_script			= 15,
			pdfa_mess_lang				= 16,
			pdfa_mess_struct_tree			= 17,
			pdfa_mess_output_intents		= 18,
			pdfa_mess_annot_type			= 19,
			pdfa_mess_action_type			= 20,
			pdfa_mess_widget_actions		= 21,
			pdfa_mess_annot_opacity			= 22,
			pdfa_mess_annot_flags			= 23,
			pdfa_mess_page_actions			= 24,
			pdfa_mess_image_alternates		= 25,
			pdfa_mess_image_opi			= 26,
			pdfa_mess_image_interpolate		= 27,
			pdfa_mess_rendering_intent		= 28,
			pdfa_mess_font_embedding		= 29,
			pdfa_mess_xobject_opi			= 30,
			pdfa_mess_xobject_ps			= 31,
			pdfa_mess_xobject_ref			= 32,
			pdfa_mess_smask				= 33,
			pdfa_mess_transparency			= 34,
			pdfa_mess_jpx_compression		= 35,
			pdfa_mess_lzw_compression		= 36,
			pdfa_mess_crypt_filter			= 37,
			pdfa_mess_external_stream		= 38,
			pdfa_mess_perms				= 39,
			pdfa_mess_blend_mode			= 40,
			pdfa_mess_glyph_widths			= 41,
			pdfa_mess_font_cidset			= 42,
			pdfa_mess_font_tounicode		= 43,
			pdfa_mess_page_userunit			= 44,
			pdfa_mess_missing_glyph			= 45,
			pdfa_mess_struct_type			= 46,
			pdfa_mess_struct_lang			= 47,
			pdfa_mess_embedded_files		= 48,
			pdfa_mess_renditions			= 49,
			pdfa_mess_alternate_presentations	= 50,
			pdfa_mess_page_pressteps		= 51,
			pdfa_mess_file_association              = 52,
			pdfa_mess_font_descriptor               = 53,
			pdfa_mess_glyph_widths_font             = 54,
			pdfa_mess_device_cmyk                   = 55,
			pdfa_mess_image_color_space             = 56,
			pdfa_mess_image_bpc                     = 57,
			pdfa_mess_image_mask                    = 58,
			pdfa_mess_font_charset			= 59,
			pdfa_mess_invalidate_sign               = 60,
			pdfa_mess_unknown_charcode              = 61,
			pdfa_mess_outline                       = 62,
			pdfa_mess_metadata                      = 63,
			pdfa_mess_overprint			= 64,
			pdfa_mess_file_spec                     = 65,
			pdfa_mess_change_font_type              = 66,
			pdfa_mess_dif_colorants                 = 67,
			pdfa_mess_font_cmap_name		= 68,
			pdfa_mess_type				= 0xFFF
		};

		interface IMessagePDFA
		{
			virtual sx_flags get_Type() const = 0;
		};

		interface IStatusPDFA
		{
			virtual sx_bool OnMessage(IMessagePDFA* pMess) = 0;
		};
	} // namespace PDF
} // namespace SX
