// ********************************************************************
// This is a part of the PDF Xpansion SDK 13.
// Copyright (C) 2002-2018 soft Xpansion
// All rights reserved.
//
// This source code is only intended as a supplement to the PDF Xpansion SDK 
// and related electronic documentation provided with the libraries.
// ********************************************************************
#pragma once
#include "../basic.h"
namespace SX
{
	namespace XPS
	{
		interface IDocument;

		const object_type obj_type_xps_link = 0x25;
		
		//////////////////////////////////////////////////////////////////////////
		// ILink
		interface ILink : public IRefObject
		{
			virtual sx_bool IsLocal() const = 0;
			virtual sx_uint get_Page() const = 0;
			virtual IStr* get_NamedDest() const = 0;
			virtual IDocument* get_Target() const = 0;
			virtual IStr* get_URI() const = 0;
			virtual sx_bool GetRectArea(sx_rect& box) const = 0;
		};

		//////////////////////////////////////////////////////////////////////////
		// ILinks
		interface ILinks
		{
			virtual sx_uint get_Count() const = 0;
			virtual ILink* Item(sx_uint uItem) const = 0;
			virtual ILink* FindItem(const sx_point &p, ILink* pFrom = nullptr) = 0;
			virtual void AddLocal(sx_str sName, const sx_rect &rc, IDocument *pTarget = nullptr) = 0;
			virtual void AddLocal(sx_uint uPage, const sx_rect &rc) = 0;
			virtual void AddURI(sx_str sURI, const sx_rect &rc) = 0;
			virtual void Remove(sx_uint uItem) = 0;
		};
	} // namespace XPS
} // namespace SX
