// ********************************************************************
// This is a part of the PDF Xpansion SDK 13.
// Copyright (C) 2002-2018 soft Xpansion
// All rights reserved.
//
// This source code is only intended as a supplement to the PDF Xpansion SDK 
// and related electronic documentation provided with the libraries.
// ********************************************************************
#pragma once
#include "../basic.h"

namespace SX
{
	namespace XPS
	{
		//////////////////////////////////////////////////////////////////////////
		// IOutlineItem
		interface IDocument;
		interface IOutlineItem
		{
			//////////////////////////////////////////////////////////////////////////
			// properties
			virtual IStr* get_Title() const = 0;
			virtual void set_Title(sx_str sTitle) = 0;
			virtual sx_uint get_Page() const = 0;
			virtual IStr* get_NamedDest() const = 0;
			virtual IDocument* get_Target() const = 0;
			virtual IStr* get_URI() const = 0;

			//////////////////////////////////////////////////////////////////////////
			// methods
			virtual sx_bool IsLocal() const = 0;
			virtual void SetLocal(sx_str sName, IDocument *pTarget) = 0;
			virtual void SetURI(sx_str sURI) = 0;

			virtual IOutlineItem* Parent() = 0;
			virtual IOutlineItem* FirstChild() = 0;
			virtual IOutlineItem* NextChild(IOutlineItem* pPrev) = 0;
			virtual IOutlineItem* InsertChild(sx_str sTitle, IOutlineItem* pBeforeChild = nullptr) = 0;
			virtual void RemoveChild(IOutlineItem* pItem) = 0;
			virtual void Move(IOutlineItem* pNewParent, IOutlineItem* pBeforeChild = nullptr) = 0;
		};

		//////////////////////////////////////////////////////////////////////////
		// IDocStructure
		interface IDocStructure
		{
			virtual IOutlineItem* GetOutline(sx_str sLang = nullptr) = 0;
			virtual IStr* GetOutlineLang() const = 0;
			virtual IOutlineItem* FindOutlineItem(sx_uint page) = 0;
		};

	} // namespace XPS
} // namespace SX
