// ********************************************************************
// This is a part of the PDF Xpansion SDK 13.
// Copyright (C) 2002-2018 soft Xpansion
// All rights reserved.
//
// This source code is only intended as a supplement to the PDF Xpansion SDK 
// and related electronic documentation provided with the libraries.
// ********************************************************************
#pragma once
#include "../basic.h"

namespace SX
{
	namespace Graphics{interface IDrawingContext; interface IBitmapData;}
	namespace Content {interface IRichContent; }
	interface ITextRegion;
	namespace XPS
	{
		interface ILinks;

		const object_type obj_type_xps_page = 0x24;
		
		//////////////////////////////////////////////////////////////////////////
		// document page 
		interface IPage : public IRefObject
		{
			//////////////////////////////////////////////////////////////////////////
			// properties
			virtual sx_double get_Width() = 0;
			virtual void set_Width(sx_double w) = 0;
			virtual sx_double get_Height() = 0;
			virtual void set_Height(sx_double h) = 0;
			virtual IStr* get_Lang() = 0;
			virtual void set_Lang(sx_str lang) = 0;
			virtual ILinks* get_Links() = 0;

			//////////////////////////////////////////////////////////////////////////
			// methods
			virtual void CalcMatrix(sx_matrix& m, sx_double dZoom = 1.0, sx_rotation_angle angle = sx_rotation_angle_0, sx_double dx = 0., sx_double dy = 0., sx_uint uDPI = 96 ) = 0;
			virtual void ApplyTransformation(const sx_matrix& transform, sx_bool bChangeBounds = false, sx_str sName = nullptr) = 0;
			virtual sx_bool StartDraw(Graphics::IDrawingContext* ctx, sx_matrix* pTransform = nullptr, sx_flags flags = 0, sx_flags annots = 0) = 0;
			virtual sx_bool StartPrint(Graphics::IDrawingContext* ctx, sx_matrix* pTransform = nullptr, sx_flags flags = 0) = 0;
			virtual Graphics::IBitmapData* CopyToBitmap(sx_matrix* pTransform = nullptr, sx_flags flags = 0) = 0;
			virtual Graphics::IBitmapData* CopyToBitmap(const sx_color_i_rgba& back, sx_matrix* pTransform = nullptr, sx_flags flags = 0) = 0;
			virtual void Compact() = 0;

			virtual IStr* GetPlainText(sx_flags opt = 0) = 0;
			virtual SX::ITextRegion* GetTextRegion(sx_flags opt = 0) = 0;
			virtual SX::Content::IRichContent* GetRichContent(sx_flags flags = 0) = 0;
		};
	}
}
