// ********************************************************************
// This is a part of the PDF Xpansion SDK 13.
// Copyright (C) 2002-2018 soft Xpansion
// All rights reserved.
//
// This source code is only intended as a supplement to the PDF Xpansion SDK 
// and related electronic documentation provided with the libraries.
// ********************************************************************

#pragma once

namespace SX
{
	// error codes
	enum ErrorCode
	{

		ErrorNone			= 0, // no error

		ErrorPathNotFound = 0x3, // file or folder not found
		ErrorAccessDenied = 0x5, // access denied
		ErrorOutOfMemory = 0xE, // not enough memory
		ErrorOutOfSpace = 0x70, // not enough disk space

		ErrorLibrary = 0x4000, // undefined/common library error
		ErrorSystem, 
		ErrorAuthFailed, //authority failed
		ErrorOutOfRange, // invalid index
		ErrorPermDenied, // no permissions
		ErrorInvalidFormat, // invalid data format
		ErrorNotImplemented, // not implemented function
		ErrorInvalidParam, // invalid param
		ErrorInvalidUse, // invalid using
		ErrorNonConform, // operation is nonconform
		ErrorBreakProcessing, // break processing
		ErrorDocSecurity, // invalid params of doc encryption
		ErrorCryptoEngine, // crypto function failed
		ErrorInternetConnect

	};

	// exception
	interface IException 
	{
		virtual ErrorCode get_ErrorCode() const = 0;
	};
} // namespace SX