// ********************************************************************
// This is a part of the PDF Xpansion SDK 13.
// Copyright (C) 2002-2018 soft Xpansion
// All rights reserved.
//
// This source code is only intended as a supplement to the PDF Xpansion SDK 
// and related electronic documentation provided with the libraries.
// ********************************************************************

#pragma once

namespace SX
{
	// ISO 639-1
	enum LangCode2
	{
		LangCode2_unk	= 0,
		LangCode2_bg	= 'bg',
		LangCode2_bs	= 'bs',
		LangCode2_hr	= 'hr',
		LangCode2_cs	= 'cs',
		LangCode2_da	= 'da',
		LangCode2_de	= 'de',
		LangCode2_en	= 'en',
		LangCode2_el	= 'el',
		LangCode2_et	= 'et',
		LangCode2_fi	= 'fi',
		LangCode2_fr	= 'fr',
		LangCode2_he	= 'he',
		LangCode2_hu	= 'hu',
		LangCode2_ga	= 'ga',
		LangCode2_is	= 'is',
		LangCode2_it	= 'it',
		LangCode2_ja	= 'ja',
		LangCode2_ko	= 'ko',
		LangCode2_lb	= 'lb',
		LangCode2_lt	= 'lt',
		LangCode2_lv	= 'lv',
		LangCode2_mk	= 'mk',
		LangCode2_mt	= 'mt',
		LangCode2_nl	= 'nl',
		LangCode2_no	= 'no',
		LangCode2_pl	= 'pl',
		LangCode2_pt	= 'pt',
		LangCode2_ro	= 'ro',
		LangCode2_ru	= 'ru',
		LangCode2_sr	= 'sr',
		LangCode2_sk	= 'sk',
		LangCode2_sl	= 'sl',
		LangCode2_es	= 'es',
		LangCode2_sv	= 'sv',
		LangCode2_tr	= 'tr',
		LangCode2_uk	= 'uk',
		LangCode2_zh	= 'zh'
	};

	// ISO 3166-1
	enum CountryCode2
	{
		CountryCode2_unk = 0,
		CountryCode2_AL  = 'AL',
		CountryCode2_AD  = 'AD',
		CountryCode2_AT  = 'AT',
		CountryCode2_BA  = 'BA',
		CountryCode2_BG  = 'BG',
		CountryCode2_CA  = 'CA',
		CountryCode2_CN  = 'CN',
		CountryCode2_HR  = 'HR',
		CountryCode2_CZ  = 'CZ',
		CountryCode2_CY  = 'CY',
		CountryCode2_DK  = 'DK',
		CountryCode2_EE  = 'EE',
		CountryCode2_FI  = 'FI',
		CountryCode2_FR  = 'FR',
		CountryCode2_DE  = 'DE',
		CountryCode2_GR  = 'GR',
		CountryCode2_HK  = 'HK',
		CountryCode2_HU  = 'HU',
		CountryCode2_IS  = 'IS',
		CountryCode2_IE  = 'IE',
		CountryCode2_IL  = 'IL',
		CountryCode2_IT  = 'IT',
		CountryCode2_JP  = 'JP',
		CountryCode2_KR  = 'KR',
		CountryCode2_LV  = 'LV',
		CountryCode2_LI  = 'LI',
		CountryCode2_LT  = 'LT',
		CountryCode2_LU  = 'LU',
		CountryCode2_MK  = 'MK',
		CountryCode2_MX  = 'MX',
		CountryCode2_MC  = 'MC',
		CountryCode2_NL  = 'NL',
		CountryCode2_NZ  = 'NZ',
		CountryCode2_NO  = 'NO',
		CountryCode2_PL  = 'PL',
		CountryCode2_PT  = 'PT',
		CountryCode2_RU  = 'RU',
		CountryCode2_SM  = 'SM',
		CountryCode2_RS  = 'RS',
		CountryCode2_SG  = 'SG',
		CountryCode2_SI  = 'SI',
		CountryCode2_SB  = 'SB',
		CountryCode2_ES  = 'ES',
		CountryCode2_SE  = 'SE',
		CountryCode2_CH  = 'CH',
		CountryCode2_TR  = 'TR',
		CountryCode2_UA  = 'UA',
		CountryCode2_GB  = 'GB',
		CountryCode2_US  = 'US'
	};


	// ISO ISO 4217 3A
	enum CurrCode3
	{
		CurrCode3_unk = 0,
		CurrCode3_AUD = 'AUD',
		CurrCode3_BAM = 'BAM',
		CurrCode3_BGN = 'BGN',
		CurrCode3_CAD = 'CAD',
		CurrCode3_CHF = 'CHF',
		CurrCode3_CNY = 'CNY',
		CurrCode3_CZK = 'CZK',
		CurrCode3_DKK = 'DKK',
		CurrCode3_EUR = 'EUR',
		CurrCode3_GBP = 'GBP',
		CurrCode3_HKD = 'HKD',
		CurrCode3_HRK = 'HRK',
		CurrCode3_HUF = 'HUF',
		CurrCode3_ILS = 'ILS',
		CurrCode3_ISK = 'ISK',
		CurrCode3_JPY = 'JPY',
		CurrCode3_KRW = 'KRW',
		CurrCode3_MKD = 'MKD',
		CurrCode3_MXN = 'MXN',
		CurrCode3_MYR = 'MYR',
		CurrCode3_NOK = 'NOK',
		CurrCode3_NZD = 'NZD',
		CurrCode3_PLN = 'PLN',
		CurrCode3_RON = 'RON',
		CurrCode3_RSD = 'RSD',
		CurrCode3_RUB = 'RUB',
		CurrCode3_SEK = 'SEK',
		CurrCode3_SGD = 'SGD',
		CurrCode3_TRY = 'TRY',
		CurrCode3_TWD = 'TWD',
		CurrCode3_UAH = 'UAH',
		CurrCode3_USD = 'USD'
	};
} // namespace SX