#pragma once

namespace Sample
{
	//////////////////////////////////////////////////////////////////////////
	// CPDFXpansionSDK
	class CPDFXpansionSDK : public IPDFXpansionSDK, public SX::ZUGFeRD::IValidationStatus
	{
	public:
		CPDFXpansionSDK();
		~CPDFXpansionSDK();

		bool Init(ISampleAppUI* pUI);
		void ProcessInvoice(SX::ZUGFeRD::IInvoice *pInvoice);
	protected:
		// IPDFXpansionSDK
		virtual HWND CreateViewer(HWND hParent, UINT w, UINT h);
		virtual SX::Viewer::IViewer* GetViewer();
		virtual void OpenInvoice();
		virtual void OpenInvoiceXML();
		virtual void CreateInvoice();

		// IValidationStatus
		virtual sx_bool OnMessage(SX::ZUGFeRD::IValidationMessage* pMess);

	private:
		// members
		HMODULE m_hPDFXpansion;
		SX::IApplication* m_pApp;
		SX::Viewer::IWinViewer* m_pDefViewer;
		ISampleAppUI* m_pUI;
		CString GetFilePath(const CString& sFileName);
		void ShowErrorMessage(SX::ErrorCode err);

	};
} // namespace Sample