// stdafx.h : include file for standard system include files,
// or project specific include files that are used frequently,
// but are changed infrequently

#pragma once

#include <SDKDDKVer.h> // target version

// ATL
#define _ATL_NO_COM_SUPPORT
#include "resource.h"
#include <atlbase.h>
#include <atlctl.h>
#include <atlwin.h>
#include <atlstr.h>
#include <atlpath.h>

// PDF Xpansion SDK
#define SX_WINDESKTOP_DLL
#define SX_USE_OBJ_PTR

#include "../../../include/app.h"
#include "../../../include/viewer.h"
#include "../../../include/PDF/document.h"
#include "../../../include/XPS/package.h"
#include "../../../include/XPS/document.h"
#include "../../../include/PDF/pages.h"
#include "../../../include/PDF/security.h"
#include "../../../include/PDF/properties.h"
#include "../../../include/PDF/zugferd.h"


using namespace SX;

namespace Sample
{
	typedef SX::ObjPtr<SX::Viewer::IViewer> IViewerPtr;
	typedef SX::ObjPtr<SX::Viewer::IViewableDocument> IVDocPtr;
	typedef SX::ObjPtr<SX::PDF::IDocument> IPDFDocPtr;
	typedef SX::ObjPtr<SX::XPS::IPackage> IXPSPackPtr;
	typedef SX::ObjPtr<SX::PDF::IPage> IPDFPagePtr;
	

	interface ISampleAppUI
	{
		virtual int MessageBox(LPCTSTR lpText, UINT uType) = 0;
		virtual bool OpenFileDialog( LPCWSTR ext, CString& sPath ) = 0;
		virtual bool SaveFileDialog( LPCWSTR ext, CString& sPath ) = 0;
 	};

	interface IPDFXpansionSDK
	{
		virtual HWND CreateViewer(HWND hParent, UINT w, UINT h) = 0;
		virtual SX::Viewer::IViewer* GetViewer() = 0;
		virtual void OpenInvoice() = 0;
		virtual void OpenInvoiceXML() = 0;
		virtual void CreateInvoice() = 0;
	};
};