#pragma once

namespace Sample
{
	//////////////////////////////////////////////////////////////////////////
	// CMainFrame
	class CMainFrame : public ATL::CWindowImpl<CMainFrame>, public ISampleAppUI
	{
	public:
		CMainFrame(IPDFXpansionSDK* pSDK);
		bool CreateFrame(int nShowWindow);

	protected:
		//////////////////////////////////////////////////////////////////////////
		// interface ISampleAppUI
		virtual int MessageBox(LPCTSTR lpText, UINT uType);
		virtual bool OpenFileDialog( LPCWSTR ext, CString &sPath );

		//////////////////////////////////////////////////////////////////////////
		// override methods
		virtual void OnFinalMessage(_In_ HWND);

		//////////////////////////////////////////////////////////////////////////
		// message handlers
		LRESULT OnSize(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL &bHandled);
		LRESULT OnInitMenuPopup(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL &bHandled);

		//////////////////////////////////////////////////////////////////////////
		// command handlers	
		LRESULT OnCloseCommand(UINT uMsg, WPARAM wParam, HWND hWnd, BOOL &bHandled);
		LRESULT OnFileCommand(UINT uMsg, WPARAM wParam, HWND hWnd, BOOL &bHandled);
		LRESULT OnViewerCommand(UINT uMsg, WPARAM wParam, HWND hWnd, BOOL &bHandled);

		//////////////////////////////////////////////////////////////////////////
		// atl message map
		BEGIN_MSG_MAP (CMainFrame)
			MESSAGE_HANDLER(WM_SIZE, OnSize)
			MESSAGE_HANDLER(WM_INITMENUPOPUP, OnInitMenuPopup)
			COMMAND_ID_HANDLER(ID_FILE_EXIT, OnCloseCommand)
			COMMAND_RANGE_HANDLER(ID_FILE_F, ID_FILE_L, OnFileCommand)
			COMMAND_RANGE_HANDLER(ID_VIEWER_F, ID_VIEWER_L, OnViewerCommand)
		END_MSG_MAP();

	private:
		// misc

		// members
		IPDFXpansionSDK* m_pSDK;
		HWND m_hViewer;
	};
} // namespace Sample