#pragma once

namespace Sample
{
	//////////////////////////////////////////////////////////////////////////
	// CPDFXpansionSDK
	class CPDFXpansionSDK : public IPDFXpansionSDK
	{
	public:
		CPDFXpansionSDK();
		~CPDFXpansionSDK();

		bool Init(ISampleAppUI* pUI);
	protected:
		// IPDFXpansionSDK
		virtual HWND CreateViewer(HWND hParent, UINT w, UINT h);
		virtual SX::Viewer::IViewer* GetViewer();
		virtual void OpenPDF();
		virtual void OpenXPS();
		virtual bool CheckSecurity(SX::PDF::IDocSecurity* pDocSecurity);
		virtual void SavePDF();
		virtual void CombineWithPDF();
		virtual void CombineWithXPS();
		virtual void ImportSVG();
		virtual void ImportEMF();
		virtual void ImportTXT();
		virtual void ImportIMG();
		virtual void ShowErrorMessage(SX::ErrorCode err);
		virtual void ShowDocument(SX::IBaseDocument* pBaseDoc);
		virtual void CombineDocuments(SX::IBaseDocument* pBaseDoc, SX::sx_flags flags);
		virtual SX::sx_bool IsPDF();
		virtual SX::sx_bool IsModified();
		virtual void SplitPDF();
		virtual void ExportXPS();

	private:
		// members
		HMODULE m_hPDFXpansion;
		SX::IApplication* m_pApp;
		SX::Viewer::IWinViewer* m_pDefViewer;
		ISampleAppUI* m_pUI;
		IPDFDocPtr m_ptrDoc;
		//SX::ObjPtr<SX::IBaseDocument> m_ptrBaseDoc;
	};

	class CLoadProvider: public SX::ILoadProvider{

	public:
		CLoadProvider(CString rootObjPath, SX::IApplication *pApp);
		virtual SX::ISequentialStream* GetExtResource(sx_str sURL);
		virtual SX::ILoadProvider* GetResourceProvider(sx_str sURL){ return nullptr; }
		virtual SX::ISequentialStream* ILoadProvider::GetResource(sx_str sURL, sx_str sContType){ return nullptr; }

	protected:
		CString m_sDir;
		SX::IApplication *m_pApp;
	};

} // namespace Sample