#include "stdafx.h"
#include "GDI2PDF.h"
#include <Gdiplus.h>
#include <GdiplusGraphics.h>
#pragma comment(lib,"gdiplus.lib")
namespace Sample
{

	//////////////////////////////////////////////////////////////////////////
	CGDI2PDF::CGDI2PDF(SX::IAppFactory* pAppFactory):m_pAppFactory(pAppFactory)
	{
		Gdiplus::GdiplusStartupInput gdiplusStartupInput;
		GdiplusStartup(&m_gdiplusToken, &gdiplusStartupInput, NULL);
	}

	//////////////////////////////////////////////////////////////////////////
	CGDI2PDF::~CGDI2PDF()
	{
		Gdiplus::GdiplusShutdown(m_gdiplusToken);
	}

	//////////////////////////////////////////////////////////////////////////
	SX::ISequentialStream* CGDI2PDF::DrawPage(SX::sx_uint ind)
	{
		HDC hdc = GetDC(0);
		Gdiplus::RectF pageRect(0, 0, 595.3f, 841.9f);
		Gdiplus::Metafile metafile(hdc, pageRect, Gdiplus::MetafileFrameUnitPoint, Gdiplus::EmfTypeEmfPlusOnly);
		ReleaseDC(NULL, hdc);
		{
			// draw page on metafile graphics
			Gdiplus::Graphics graphics(&metafile);
			Gdiplus::Font font(&Gdiplus::FontFamily(L"Arial"), 24);
			CString sPageNum; sPageNum.Format(L"Page: %d", ind + 1);
			Gdiplus::PointF startPoint(0, 0); Gdiplus::RectF textBBox;
			graphics.MeasureString(sPageNum, sPageNum.GetLength(), &font, startPoint, &textBBox);
			Gdiplus::SolidBrush* brush = new Gdiplus::SolidBrush(Gdiplus::Color());
			startPoint.X = pageRect.Width - textBBox.Width;
			graphics.DrawString(sPageNum, sPageNum.GetLength(), &font, startPoint, brush);
			delete brush;
			// release graphics object
		}
		// get metafile data
		HENHMETAFILE hMetaFile = metafile.GetHENHMETAFILE();
		sx_uint buffSize = GetEnhMetaFileBits(hMetaFile, 0, NULL);
		sx_byte* buffer = new sx_byte[buffSize];
		GetEnhMetaFileBits(hMetaFile, buffSize, buffer);
		DeleteEnhMetaFile(hMetaFile);
		// copy metafile data to stream
		SX::ObjPtr<SX::ISequentialStream> ptrStream = m_pAppFactory->CreateSequentialStream();
		ptrStream->Write(buffer, buffSize);
		ptrStream->Reset();
		// free resources

		delete [] buffer;
		return ptrStream.release();
	}

}