#pragma once

namespace Sample
{
	//////////////////////////////////////////////////////////////////////////
	// CPDFXpansionSDK
	class CPDFXpansionSDK : public IPDFXpansionSDK
	{
	public:
		CPDFXpansionSDK();
		~CPDFXpansionSDK();

		bool Init(ISampleAppUI* pUI);
	protected:
		// IPDFXpansionSDK
		virtual HWND CreateViewer(HWND hParent, UINT w, UINT h);
		virtual SX::Viewer::IViewer* GetViewer();
		virtual void CreatePDF();
		virtual void SavePDF();
		virtual void CreateEMF();
		SX::sx_bool IsPDF();

	private:
		SX::Content::IRichObject* AddRectangle(SX::Content::IRichContent* rc, const SX::sx_rect& rect, const SX::sx_color& fillColor, const SX::sx_color& strokeColor);
		SX::Content::IRichText* AddText(SX::Content::IRichContent* rc, const SX::sx_rect& rect, const CString& text, SX::Content::ITextStyle* pTextStyle, SX::Content::IRichText* richText = nullptr);
		SX::Content::IRichObject* AddImage(SX::Content::IRichContent* rc, const CString& imagePath, const SX::sx_rect& rect);
		SX::sx_rect& AddBlock(SX::Content::IRichContent* rc, SX::sx_rect& rect, const CString& sImagePath, const CString& sHeader, const CString& sBody);
		SX::PDF::IPage* CreatePage(SX::PDF::IDocument* pDoc, sx_double w, sx_double h);
		CString GetFilePath(const CString& sFileName);
		void InitTextStyles(SX::Content::IRichContent* pRichContent);
		void FillPage(SX::Content::IRichContent* rc);
		void ShowErrorMessage(SX::ErrorCode err);
		// members
		HMODULE m_hPDFXpansion;
		SX::IApplication* m_pApp;
		SX::Viewer::IWinViewer* m_pDefViewer;
		ISampleAppUI* m_pUI;
		IPDFDocPtr m_ptrDoc;
		
		SX::Content::ITextStyle* m_pBlackNormal10;
		SX::Content::ITextStyle* m_pBlackBold10;
		SX::Content::ITextStyle* m_pBlueNormal10;
		SX::Content::ITextStyle* m_pBlackNormal22;
		SX::Content::ITextStyle* m_pWhiteNormal22;
		SX::Content::ITextStyle* m_pBlueNormal17;
	};
} // namespace Sample