#pragma once

namespace Sample
{
	//////////////////////////////////////////////////////////////////////////
	// CPDFXpansionSDK
	class CPDFXpansionSDK : public IPDFXpansionSDK, public SX::PDF::IStatusPDFA
	{
	public:
		CPDFXpansionSDK();
		~CPDFXpansionSDK();

		bool Init(ISampleAppUI* pUI);

		//IStatusPDFA
		virtual sx_bool OnMessage(SX::PDF::IMessagePDFA* pMess) override;

	protected:
		// IPDFXpansionSDK
		virtual HWND CreateViewer(HWND hParent, UINT w, UINT h);
		virtual SX::Viewer::IViewer* GetViewer();
		virtual void OpenPDF();
		virtual void OpenXPS();
		virtual bool CheckSecurity(SX::PDF::IDocSecurity* pDocSecurity);
		virtual void ExportText();
		virtual void ExportPagesAsImages();
		virtual bool CanExport();
		virtual void ExportPDFA();

	private:
		// members
		HMODULE m_hPDFXpansion;
		SX::IApplication* m_pApp;
		SX::Viewer::IWinViewer* m_pDefViewer;
		ISampleAppUI* m_pUI;
		IPDFDocPtr m_ptrDoc;
		void ShowErrorMessage(SX::ErrorCode err);
	};
} // namespace Sample