#pragma once

namespace Sample
{
	//////////////////////////////////////////////////////////////////////////
	// CPDFXpansionSDK
	class CPDFXpansionSDK : public IPDFXpansionSDK
	{
	public:
		CPDFXpansionSDK();
		~CPDFXpansionSDK();

		bool Init(ISampleAppUI* pUI);
	protected:
		// IPDFXpansionSDK
		virtual HWND CreateViewer(HWND hParent, UINT w, UINT h);
		virtual SX::Viewer::IViewer* GetViewer();
		virtual void OpenPDF();
		virtual void OpenXPS();
		virtual bool CheckSecurity(SX::PDF::IDocSecurity* pDocSecurity);
		virtual void CheckSignatures(SX::PDF::ISignatures* pSignatures);
		virtual void ShowSignatureInfo(SX::PDF::IFormField* pFormField);
		virtual void TimeStructCopy(SYSTEMTIME &source, SX::sx_time &destination);
		virtual void Sign();
		virtual void SavePDF();
		virtual void ShowErrorMessage(SX::ErrorCode err);
		virtual SX::sx_bool IsPDF();
		virtual SX::sx_bool IsModified();

	private:
		// members
		HMODULE m_hPDFXpansion;
		SX::IApplication* m_pApp;
		SX::Viewer::IWinViewer* m_pDefViewer;
		ISampleAppUI* m_pUI;
		IPDFDocPtr m_ptrDoc;
		//IBaseDocumentPtr m_ptrBaseDoc;
	};
} // namespace Sample