#pragma once

namespace Sample
{
	//////////////////////////////////////////////////////////////////////////
	// CPDFXpansionSDK
	class CPDFXpansionSDK : public IPDFXpansionSDK, public SX::Viewer::IViewerEvents
	{
	public:
		CPDFXpansionSDK();
		~CPDFXpansionSDK();

		bool Init(ISampleAppUI* pUI);
	protected:
		// IPDFXpansionSDK
		virtual HWND CreateViewer(HWND hParent, UINT w, UINT h);
		virtual SX::Viewer::IViewer* GetViewer();
		virtual void OpenPDF();
		virtual void OpenXPS();
		virtual bool CheckSecurity(SX::PDF::IDocSecurity* pDocSecurity);
		virtual SX::sx_bool OnEvent(SX::Viewer::IViewerEvent* pEvent);
		void ShowErrorMessage(SX::ErrorCode err);

		void OnToolInk(SX::Viewer::IToolInk *pInk);
		void OnToolEraser(SX::Viewer::IToolEraser *pEraser);

		SX::sx_bool IsModified();
		virtual void SavePDF();
		virtual void SetInkTool();
		virtual void SetEraserTool();
		virtual SX::sx_bool IsPDF();
		virtual SX::sx_bool IsInk();
		virtual SX::sx_bool IsEraser();

	private:
		// members
		HMODULE m_hPDFXpansion;
		SX::IApplication* m_pApp;
		SX::Viewer::IWinViewer* m_pDefViewer;
		ISampleAppUI* m_pUI;
		SX::ObjPtr<SX::PDF::IDocument> m_ptrDoc;

		SX::sx_uint m_uAnnotPage;
		SX::sx_bool m_bAnnotCreated;
	};
} // namespace Sample