#pragma once

namespace Sample
{
	//////////////////////////////////////////////////////////////////////////
	// CPDFXpansionSDK
	class CPDFXpansionSDK : public IPDFXpansionSDK, public SX::Viewer::IViewerEvents, public JS::IJSEvents
	{
	public:
		CPDFXpansionSDK();
		~CPDFXpansionSDK();

		bool Init(ISampleAppUI* pUI);
	protected:
		// IPDFXpansionSDK
		virtual HWND CreateViewer(HWND hParent, UINT w, UINT h);
		virtual SX::Viewer::IViewer* GetViewer();
		virtual void OpenPDF();
		virtual void OpenXPS();
		virtual bool CheckSecurity(SX::PDF::IDocSecurity* pDocSecurity);

		// SX::Viewer::IViewerEvents
		virtual sx_bool OnEvent(SX::Viewer::IViewerEvent* pEvent);
		//	JS::IJSEvents
		virtual sx_bool OnEvent(SX::JS::IJSEvent* pEvent);

	        void OnAnnotEvent(SX::Viewer::IViewerEvent_PDF_Annot *pEvAnnot);
		//	JScript
		sx_bool InitJSTools(ISampleAppUI* pUI);
		void OnEventFormField(IDocFieldEvent *pEvField);
		
	private:
		// members
		HMODULE m_hPDFXpansion;
		SX::IApplication* m_pApp;
		SX::Viewer::IWinViewer* m_pDefViewer;
		ISampleAppUI* m_pUI;
		//IBaseDocumentPtr m_ptrBaseDoc;


		//	JScript
		HMODULE m_hJSLib;
		SX::JS::IJSTools *m_pJSTools;
		SX::JS::IJSApp *m_pJSApp;
		SX::JS::IJSDoc *m_pJSDoc;

	        SX::PDF::IDocument *m_pPDFDoc;
	};
} // namespace Sample