// CPasswordDlg.h : Declaration of the CCPasswordDlg

#pragma once

#include "resource.h"       // main symbols
#include <vector>
#include <atlhost.h>
#include "AddOutlineDlg.h"
#include "..\..\..\include\PDF\outline.h"
#include <commctrl.h>

using namespace ATL;


// CCPasswordDlg

class CCOutlinesDlg : 
	public CAxDialogImpl<CCOutlinesDlg>
{
public:
	CCOutlinesDlg(SX::Viewer::IViewer* pViewer, SX::PDF::IDocument* pDocument) : m_pViewer(pViewer), m_pDocument(pDocument)
	{
		 
	}

	~CCOutlinesDlg()
	{

	}

	enum { IDD = IDD_OUTLINE_DIALOG };
	
	BEGIN_MSG_MAP(CCOutlinesDlg)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		COMMAND_HANDLER(IDC_ADD_BUTTON, BN_CLICKED, OnClickedAddNew)
		COMMAND_HANDLER(IDC_GOTO_BUTTON, BN_CLICKED, OnClickedGoTo)
		COMMAND_HANDLER(IDC_CLOSE, BN_CLICKED, OnClickedCancel)
		NOTIFY_HANDLER(IDC_TREE_VIEW, TVN_SELCHANGED, ID_TREE_SEL_CHANGED)
		CHAIN_MSG_MAP(CAxDialogImpl<CCOutlinesDlg>)
	END_MSG_MAP()

	LRESULT ID_TREE_SEL_CHANGED(int /*idCtrl*/, LPNMHDR pNMHDR, BOOL& /*bHandled*/);

protected:
	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnClickedAddNew(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnClickedGoTo(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT CCOutlinesDlg::OnClickedCancel(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	void LoadDocumentOutlines();
	HTREEITEM AddTreeItem(CString text, SX::PDF::IOutlineItem* pOutline, HTREEITEM hParrent = TVI_ROOT);
	void AddChilds(SX::PDF::IOutlineItem* pParentOutline, HTREEITEM hParentNode);
	SX::PDF::IOutlineItem* GetSelectedOutline(OUT HTREEITEM& hSelectedNode);
	SX::sx_bool HasDestination(SX::PDF::IOutlineItem* pOutline);

	std::vector<SX::PDF::IOutlineItem*> m_vOutlines;
	SX::Viewer::IViewer* m_pViewer;
	SX::PDF::IDocument* m_pDocument;
	CWindow m_cwTreeView, m_cwAddButton, m_cwGoToButton;
	HTREEITEM m_hRootItem;
};


