#pragma once
//#include "../../../../include/viewer.h"

//interface SX::Viewer::IViewerEvents;
//interface IViewerEvent;

namespace Sample
{
	//////////////////////////////////////////////////////////////////////////
	// CPDFXpansionSDK
	class CPDFXpansionSDK : public SX::Viewer::IViewerEvents, public IPDFXpansionSDK 
	{
	public:
		CPDFXpansionSDK();
		~CPDFXpansionSDK();

		bool Init(ISampleAppUI* pUI);
	protected:
		// IPDFXpansionSDK
		virtual HWND CreateViewer(HWND hParent, UINT w, UINT h);
		virtual SX::Viewer::IViewer* GetViewer();
		virtual void OpenPDF();
		virtual void OpenXPS();
		virtual bool CheckSecurity(SX::PDF::IDocSecurity* pDocSecurity);
		virtual void Save();
		virtual void SetStickyNote();
		virtual void SetStamp();
		SX::sx_bool IsModified();
		SX::sx_bool IsPDF();

	private:
		void ShowErrorMessage(SX::ErrorCode err);
		virtual SX::PDF::IMarkupAnnot* AddStickyNote(SX::sx_point& point, SX::PDF::IPage* page);
		virtual SX::PDF::IMarkupAnnot* AddStamp(SX::sx_rect& rect, SX::PDF::IPage* page);
		void AddPopup(SX::PDF::IMarkupAnnot* pAnnot);
		SX::sx_time GetTime();
		//IViewerEvents

		virtual sx_bool OnEvent(SX::Viewer::IViewerEvent* pEvent);
		SX::sx_bool OnToolEvent(SX::Viewer::IViewerEvent_ToolActivity* pToolActivity);
		SX::sx_bool OnMouseEvent(SX::Viewer::IViewerEvent_MouseActivity* pMouseActivity);

		// members
		HMODULE m_hPDFXpansion;
		SX::IApplication* m_pApp;
		SX::Viewer::IWinViewer* m_pDefViewer;
		ISampleAppUI* m_pUI;
		IPDFDocPtr m_ptrDoc;
		SX::Viewer::tracker_type m_toolTrackerType;
		SX::sx_rect PointsToRect(SX::sx_point& a, SX::sx_point& b);


		SX::ObjPtr<SX::PDF::IAnnot> m_ptrOverAnnot;
	};
} // namespace Sample