#pragma once

namespace Sample
{
	//////////////////////////////////////////////////////////////////////////
	// CPDFXpansionSDK
	class CPDFXpansionSDK : public IPDFXpansionSDK
	{
	public:
		CPDFXpansionSDK();
		~CPDFXpansionSDK();

		bool Init(ISampleAppUI* pUI);
	protected:
		// IPDFXpansionSDK
		virtual HWND CreateViewer(HWND hParent, UINT w, UINT h);
		virtual SX::Viewer::IViewer* GetViewer();
		virtual void OpenPDF();
		virtual void OpenXPS();
		virtual bool CheckSecurity(SX::PDF::IDocSecurity* pDocSecurity);
		virtual void SavePDF();
		virtual void AddTextMarkup(SX::PDF::annot_type annotType);
		virtual void Copy();
		virtual SX::sx_bool IsTextSelected();
		virtual SX::sx_bool IsPDF();
		virtual SX::sx_bool IsModified();
		void ShowErrorMessage(SX::ErrorCode err);

	private:
		// members
		HMODULE m_hPDFXpansion;
		SX::IApplication* m_pApp;
		SX::Viewer::IWinViewer* m_pDefViewer;
		ISampleAppUI* m_pUI;
		IPDFDocPtr m_ptrDoc;
	};
} // namespace Sample