// SearchDialog.cpp : Implementation of CSearchDialog

#include "stdafx.h"
#include "SearchDialog.h"


// CSearchDialog


void CSearchDialog::PrepareSearchProvider()
{
	GetDlgItemText(IDC_EDIT_SEARCHTEXT, sSearchText);
	if (m_pSearchProvider->get_Text() == NULL || sSearchText != m_pSearchProvider->get_Text())
	{
		m_pSearchProvider->Reset(sSearchText, m_pViewer->get_Canvas()->get_ActivePage());

	}
}

LRESULT CSearchDialog::OnBnClickedButtonNext(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	PrepareSearchProvider();
	if (m_pSearchProvider->SearchForward(this))
		m_pViewer->get_Canvas()->Navigate(m_pSearchProvider);
	else
		MessageBox(m_TextNotFound);
	return 1;
}


LRESULT CSearchDialog::OnBnClickedButtonPrev(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	PrepareSearchProvider();
	if (m_pSearchProvider->SearchBack(this))
		m_pViewer->get_Canvas()->Navigate(m_pSearchProvider);
	else
		MessageBox(m_TextNotFound);
	return 1;
}


LRESULT CSearchDialog::OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	CAxDialogImpl<CSearchDialog>::OnInitDialog(uMsg, wParam, lParam, bHandled);
	bHandled = TRUE;
	return 1; 
}


LRESULT CSearchDialog::OnClickedCancel(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	EndDialog(wID);
	return 0;
}

SX::sx_bool CSearchDialog::OnPage(sx_uint ind, sx_uint count)
{
	CString str; str.Format(L"Text found on %i of %i",ind+1, count);
	SetDlgItemText(IDC_LABEL,str);
	return true;
}
