// SearchDialog.h : Declaration of the CSearchDialog

#pragma once

#include "resource.h"       // main symbols

#include <atlhost.h>

using namespace ATL;

// CSearchDialog


class CSearchDialog : 
	public CAxDialogImpl<CSearchDialog>
	, public SX::ISearchStatus
{
public:
	CSearchDialog(SX::Viewer::IViewer* pViewer, SX::ISearchProvider* pSearchProvider)
	{
		sSearchText = "";
		m_pViewer = pViewer;
		m_pSearchProvider =  pSearchProvider;
		m_TextNotFound = L"Test not found!";

		pViewer->get_Canvas()->Navigate(m_pSearchProvider);
	}

	~CSearchDialog()
	{
		m_pViewer->get_Canvas()->ResetMarking();
	}
	
	enum { IDD = IDD_SEARCHDIALOG };

	BEGIN_MSG_MAP(CSearchDialog)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		COMMAND_HANDLER(IDCANCEL, BN_CLICKED, OnClickedCancel)
		CHAIN_MSG_MAP(CAxDialogImpl<CSearchDialog>)
		COMMAND_HANDLER(IDC_BUTTON_NEXT, BN_CLICKED, OnBnClickedButtonNext)
		COMMAND_HANDLER(IDC_BUTTON_PREV, BN_CLICKED, OnBnClickedButtonPrev)
	END_MSG_MAP()

protected:
	CString sSearchText;
	SX::Viewer::IViewer* m_pViewer;
	SX::ISearchProvider* m_pSearchProvider;
	CString m_TextNotFound;

	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnBnClickedButtonNext(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnBnClickedButtonPrev(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnClickedCancel(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);

	virtual sx_bool OnPage(sx_uint ind, sx_uint count);
	virtual void PrepareSearchProvider();

};


