//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "MainFrm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "PDF_Xpansion_ActiveX_13_OCX"
#pragma resource "*.dfm"
TMainFrame *MainFrame;

namespace Pdf_xpansion_wrapper_13_tlb
{
	typedef IApplication* (__cdecl *PDF_XPANSION_SDK_ENTRY_POINT)();
};


//---------------------------------------------------------------------------
__fastcall TMainFrame::TMainFrame(TComponent* Owner) : TForm(Owner)
{
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::FormShow(TObject *Sender)
{
	m_hXpansionModule = NULL;
	m_ptrXpansionApp = PDFXpansionControl->Application; // GetXpansionApp(); // get app object directly
	if (!m_ptrXpansionApp->Authorized)
	{
		HRESULT hr = m_ptrXpansionApp->Authorize(L"D502CB5B11E5394F932A84A46735583E3C84D62DEB804942BA50257E5C311EA2D03356126CC6CE4B89F7A0A91969660611C6404EA90C4546AB7BE23328EBF5C7", NULL);
		if (S_OK != hr)
		{
			MessageBox(NULL, L"Authorize Error!", L"ERROR", MB_OK|MB_ICONERROR);
		}
	}
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::FormDestroy(TObject *Sender)
{
	if(m_ptrXpansionApp) m_ptrXpansionApp.Reset(NULL);
	if(m_hXpansionModule) ::FreeLibrary(m_hXpansionModule);
}

//---------------------------------------------------------------------------
Pdf_xpansion_wrapper_13_tlb::IApplicationPtr TMainFrame::GetXpansionApp()
{
	m_hXpansionModule = ::LoadLibrary(L"pdf-xpansion-com-x86.dll");
	if(m_hXpansionModule)
	{
		PDF_XPANSION_SDK_ENTRY_POINT pfnEntryPoint = (PDF_XPANSION_SDK_ENTRY_POINT)GetProcAddress(m_hXpansionModule, "EntryPoint");
		if(pfnEntryPoint) 
		{
			Pdf_xpansion_wrapper_13_tlb::IApplicationPtr ptrApp(pfnEntryPoint(), false);
			return ptrApp;
		}
	}
	return NULL;
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnOpenPDF(TObject *Sender)
{
	if (OpenPDFDialog->Execute(NULL))
	{
		PDF_IDocumentPtr ptrDoc(PDFXpansionControl->Application->get_Factory()->CreatePDFDocument(), false);
		ptrDoc->OpenFile(OpenPDFDialog->FileName.w_str(), 0);
		Viewer_IViewableDocumentPtr ptrViewableDoc(ptrDoc->GetViewableDocument(), false);
		PDFXpansionControl->Viewer->Document = ptrViewableDoc;
	}
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnOpenXPS(TObject *Sender)
{
	if (OpenXPSDialog->Execute(NULL))
	{
		XPS_IPackagePtr ptrDoc(PDFXpansionControl->Application->get_Factory()->CreateXPSPackage(), false);
		ptrDoc->OpenFile(OpenXPSDialog->FileName.w_str());
		Viewer_IViewableDocumentPtr ptrViewableDoc(ptrDoc->GetViewableDocument(), false);
		PDFXpansionControl->Viewer->Document = ptrViewableDoc;
	}
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnClose(TObject *Sender)
{
	Close();
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnModeNormal(TObject *Sender)
{
	//PDFXpansionControl->Viewer->Canvas->Mode = Viewer_viewer_mode::viewer_mode_normal;
	//PDFXpansionControl->Viewer->Config->Update();
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnModeFlip(TObject *Sender)
{
	//PDFXpansionControl->Viewer->Canvas->Mode = Viewer_viewer_mode::viewer_mode_flip;
	//PDFXpansionControl->Viewer->Config->Update();
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnLayoutVertical(TObject *Sender)
{
	PDFXpansionControl->Viewer->Canvas->VerticalLayout = !PDFXpansionControl->Viewer->Canvas->VerticalLayout;
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnLayout1ColRow(TObject *Sender)
{
	PDFXpansionControl->Viewer->Canvas->LayoutMultiplicity = 1;
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnLayout2ColRow(TObject *Sender)
{
	PDFXpansionControl->Viewer->Canvas->LayoutMultiplicity = 2;
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnLayout4ColRow(TObject *Sender)
{
	PDFXpansionControl->Viewer->Canvas->LayoutMultiplicity = 4;
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnLayoutCoverPage(TObject *Sender)
{
	PDFXpansionControl->Viewer->Canvas->SeparateCover = !PDFXpansionControl->Viewer->Canvas->SeparateCover;
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnZoom50(TObject *Sender)
{
	PDFXpansionControl->Viewer->Canvas->Zoom = 0.5;
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnZoom100(TObject *Sender)
{
	PDFXpansionControl->Viewer->Canvas->Zoom = 1.0;
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnZoom200(TObject *Sender)
{
	PDFXpansionControl->Viewer->Canvas->Zoom = 2.0;
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnZoom500(TObject *Sender)
{
	PDFXpansionControl->Viewer->Canvas->Zoom = 5.0;
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnFitWidth(TObject *Sender)
{
	PDFXpansionControl->Viewer->Canvas->Fit = Viewer_viewer_fit::viewer_fit_page_width;
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnFitHeight(TObject *Sender)
{
	PDFXpansionControl->Viewer->Canvas->Fit = Viewer_viewer_fit::viewer_fit_page_height;
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnFitPage(TObject *Sender)
{
	PDFXpansionControl->Viewer->Canvas->Fit = Viewer_viewer_fit::viewer_fit_page;
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnRotateCW(TObject *Sender)
{
	PDFXpansionControl->Viewer->Canvas->Rotation = (PDFXpansionControl->Viewer->Canvas->Rotation + 90) % 360;
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnRotateCCW(TObject *Sender)
{
	PDFXpansionControl->Viewer->Canvas->Rotation = (PDFXpansionControl->Viewer->Canvas->Rotation + 270) % 360;
}

//---------------------------------------------------------------------------

