﻿//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "MainFrm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "PDF_Xpansion_ActiveX_13_OCX"
#pragma resource "*.dfm"
TMainFrame *MainFrame;

namespace Pdf_xpansion_js_13_tlb
{
	typedef IJSTools* (__cdecl *PDF_XPANSION_JS_ENTRY_POINT)();
};     // namespace Pdf_xpansion_js_13_tlb

class TJSEvents: public TCppInterfacedObject<Pdf_xpansion_js_13_tlb::IJSEvents>
{
	TMainFrame *m_frame;

public:
	TJSEvents(TMainFrame *frame): m_frame(frame)
	{
	}

	virtual HRESULT STDMETHODCALLTYPE OnEvent(Pdf_xpansion_js_13_tlb::IJSEvent* pEvent/*[in]*/, 
                                            VARIANT_BOOL* pRes/*[out,retval]*/)
	{
		*pRes = VARIANT_TRUE;

		using namespace Pdf_xpansion_js_13_tlb;
		if (pEvent) switch (pEvent->type)
		{
		case js_lib_event::js_event_invalidate:
			m_frame->PDFXpansionControl->Viewer->Invalidate(true, true);
			break;
		case js_lib_event::js_event_app_escript:
			{
				IJSEvEScriptPtr ptrJSEvEScript = pEvent;

				switch (ptrJSEvEScript->IDS)
				{
				case js_escript_str::js_escript_str_ge:
					ptrJSEvEScript->SetString(L"Ungültiger Wert: nur Werte größer oder gleich %s sind gültig.");
					break;
				case js_escript_str::js_escript_str_gt_lt:
					ptrJSEvEScript->SetString(L"Ungültiger Wert: nur Werte größer oder gleich %s und kleiner oder gleich %s sind gültig.");
					break;
				case js_escript_str::js_escript_str_le:
					ptrJSEvEScript->SetString(L"Ungültiger Wert: nur Werte kleiner oder gleich %s sind gültig.");
					break;
				case js_escript_str::js_escript_str_inv_mnt:
					ptrJSEvEScript->SetString(L"** Ungültig **");
					break;
				case js_escript_str::js_escript_str_inv_date:
					ptrJSEvEScript->SetString(L"Datum oder Zeit ungültig. Bitte prüfen Sie Ihre Angaben. Feld");
					break;
				case js_escript_str::js_escript_str_inv_date2:
					ptrJSEvEScript->SetString(L"sollte folgendes Format haben");
					break;
				case js_escript_str::js_escript_str_inv_value:
					ptrJSEvEScript->SetString(L"Das Format des eingegebenen Werts passt nicht zum Feldformat.");
					break;
				case js_escript_str::js_escript_str_month_info:
					ptrJSEvEScript->SetString(L"Januar[1]Februar[2]März[3]April[4]Mai[5]Juni[6]Juli[7]August[8]September[9]Oktober[10]November[11]Dezember[12]Sept[9]Jan[1]Feb[2]Mrz[3]Apr[4]Jun[6]Jul[7]Aug[8]Sep[9]Okt[10]Nov[11]Dez[12]");
					break;
				}
			}
			break;
		case js_lib_event::js_event_wsh_error:
			{
				IJSEvErrorPtr ptrJSEvError = pEvent;
				MessageBox(m_frame->ClientHandle, ptrJSEvError->source, ptrJSEvError->Desc, MB_ICONERROR);
			}
			break;
		case js_lib_event::js_event_app_alert:
			{
				IJSEvAlertPtr ptrJSEvAlert = pEvent;
				MessageBox(m_frame->ClientHandle, ptrJSEvAlert->Msg, ptrJSEvAlert->Title, 0);
			}
			break;
		}

		return S_OK;
	}
};

class TViewerEvents: public TCppInterfacedObject<Pdf_xpansion_wrapper_13_tlb::Viewer_IViewerEvents>
{
	TMainFrame *m_frame;

public:
	TViewerEvents(TMainFrame *frame): m_frame(frame)
	{
	}

	virtual HRESULT STDMETHODCALLTYPE OnEvent(Pdf_xpansion_wrapper_13_tlb::Viewer_IViewerEvent* pEvent/*[in]*/,
											VARIANT_BOOL* pRes/*[out,retval]*/)
	{		
		using namespace Pdf_xpansion_wrapper_13_tlb;
		if (pEvent) switch (pEvent->type)
		{
		case Viewer_viewer_event::viewer_event_doc_activity:
			{
				Viewer_ViewerEvent_DocActivityPtr ptrDocActivityEvent = pEvent;

				if (ptrDocActivityEvent->DocEvent && ptrDocActivityEvent->DocEvent->type == doc_event::doc_event_form_field)
				{
					IDocFieldEventPtr ptrDocFieldEvent = ptrDocActivityEvent->DocEvent;
					PDF_IFormFieldPtr ptrFormField = ptrDocFieldEvent->Field;
					PDF_IPDFActionsPtr ptrActions(ptrFormField->GetEventActions(ptrDocFieldEvent->PDFEvent->type, false), false);

					if (ptrActions)
					{
 						for (unsigned int i = 0; i < ptrActions->Count; ++i)
						{
							PDF_IPDFActionPtr ptrAction(ptrActions->Item(i), false);

							if (ptrAction && ptrAction->type == PDF_pdf_action::pdf_action_exec_jscript)
							{
								PDF_ActionJScriptPtr ptrActionJScript = ptrAction;
								m_frame->m_ptrJSApp->AttachScript(ptrActionJScript->JScript, m_frame->m_ptrJSDoc, ptrDocFieldEvent->PDFEvent);
							}
						}
					}
				}
			}
			break;
		case Viewer_viewer_event::viewer_event_pdf:
			{
				Viewer_ViewerEvent_PDFPtr ptrPDFEvent = pEvent;
				switch (ptrPDFEvent->PDFType)
				{
				case PDF_pdf_event::pdf_event_annot_lost_focus:
				case PDF_pdf_event::pdf_event_annot_mouse_up:
				case PDF_pdf_event::pdf_event_annot_mouse_down:
				case PDF_pdf_event::pdf_event_annot_mouse_enter:
				case PDF_pdf_event::pdf_event_annot_mouse_exit:
				case PDF_pdf_event::pdf_event_annot_get_focus:
					{
						Viewer_ViewerEvent_PDF_AnnotPtr ptrPDFAnnotEvent = ptrPDFEvent;

						if (ptrPDFAnnotEvent->Annot)
						{
							PDF_IPDFActionsPtr ptrActions(ptrPDFAnnotEvent->Annot->GetEventActions(ptrPDFEvent->PDFType), false);

							if (ptrActions)
							{
 								for (unsigned int i = 0; i < ptrActions->Count; ++i)
								{
									PDF_IPDFActionPtr ptrAction(ptrActions->Item(i), false);

									if (ptrAction)
									{
										switch (ptrAction->type)
										{
										case PDF_pdf_action::pdf_action_exec_jscript:
											{
												PDF_ActionJScriptPtr ptrActionJScript = ptrAction;
												m_frame->m_ptrJSApp->AttachScript(ptrActionJScript->JScript, m_frame->m_ptrJSDoc, ptrPDFEvent->PDFEvent);
											}
											break;
										case PDF_pdf_action::pdf_action_reset_form:
											{
												ptrPDFEvent->Doc->FormFields->ResetValues();
												ptrPDFEvent->Doc->FormFields->ResetAppearances(false);

												m_frame->PDFXpansionControl->Viewer->Invalidate(true, true);
											}
											break;
										}
									}
								}
							}
						}

					}
					break;
				}
			}
			break;
		}
		return S_OK;
	}
};

//---------------------------------------------------------------------------
__fastcall TMainFrame::TMainFrame(TComponent* Owner)
	: TForm(Owner)
{
	m_hJSLib = 0;
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::FormShow(TObject *Sender)
{
	if (!PDFXpansionControl->Application->Authorized)
	{
		HRESULT hr = PDFXpansionControl->Application->Authorize(L"D502CB5B11E5394F932A84A46735583E3C84D62DEB804942BA50257E5C311EA2D03356126CC6CE4B89F7A0A91969660611C6404EA90C4546AB7BE23328EBF5C7", NULL);
		if (S_OK != hr)
		{
			MessageBox(NULL, L"Authorize Error!", L"ERROR", MB_OK | MB_ICONERROR);
		}
		else
		{
			PDFXpansionControl->Viewer->Config->UseCache = false;
			PDFXpansionControl->Viewer->Config->PageCacheSize = 50;
			PDFXpansionControl->Viewer->Config->PageCacheInvalidation = 300;
			PDFXpansionControl->Viewer->Config->PDF->Popups = Pdf_xpansion_wrapper_13_tlb::Viewer_viewer_popups::viewer_popups_single;
			PDFXpansionControl->Viewer->Config->PDF->EnableFormFilling = true;
			PDFXpansionControl->Viewer->Config->RelayDocEvents = true;

			InitJsTools();
		}
	}
}

void TMainFrame::InitJsTools()
{
	m_hJSLib = ::LoadLibrary(L"pdf-xpansion-js-x86.dll");
	if (m_hJSLib)
	{
		PDF_XPANSION_JS_ENTRY_POINT pfnEntryPoint = (PDF_XPANSION_JS_ENTRY_POINT)GetProcAddress(m_hJSLib, "EntryPointCom");
		if (pfnEntryPoint)
		{
			m_ptrJSTools.Bind(pfnEntryPoint(), false);
			if (m_ptrJSTools)
				m_ptrJSApp.Bind(m_ptrJSTools->CreateApp(PDFXpansionControl->Application, Pdf_xpansion_js_13_tlb::LangCode2::LangCode2_unk, L"product", L"edition", 1.0), false);
		}
	}

	if (m_ptrJSApp)
	{
		PDF_IDocumentPtr ptrDoc(PDFXpansionControl->Application->get_Factory()->CreatePDFDocument(), false);
		ptrDoc->OpenFile(L"forms.pdf", 10);
		m_ptrJSApp->AttachScripts(ptrDoc, NULL);
		m_ptrJSEvents = new TJSEvents(this);
		m_ptrJSApp->SetEventHandler(m_ptrJSEvents);
	}

	m_ptrEvents = new TViewerEvents(this);
	PDFXpansionControl->Viewer->SetEventHandler(m_ptrEvents);
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::FormDestroy(TObject *Sender)
{
	if (m_ptrJSApp && m_ptrJSDoc)
		m_ptrJSApp->ReleaseDoc(m_ptrJSDoc);

	if (m_hJSLib)
		::FreeLibrary(m_hJSLib);
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnOpenPDF(TObject *Sender)
{
	using namespace Pdf_xpansion_wrapper_13_tlb;
	if (OpenPDFDialog->Execute(NULL))
	{
		PDF_IDocumentPtr ptrDoc(PDFXpansionControl->Application->get_Factory()->CreatePDFDocument(), false);
		ptrDoc->OpenFile(OpenPDFDialog->FileName.w_str(), 0);

		switch (ptrDoc->Properties->Security->Security)
		{
		case PDF_doc_security::doc_security_password:
			{
				PDF_IPasswordSecurityPtr ptrPassSec = ptrDoc->Properties->Security->StandardSecurity;
				ptrPassSec->SetUserPassword(L"");
			}
			break;
		}

		ptrDoc->FormFields->RaiseEvents = true;
		ptrDoc->FormFields->AutoCalculate = true;

		if (m_ptrJSApp)
		{
			if (m_ptrJSDoc)
				m_ptrJSApp->ReleaseDoc(m_ptrJSDoc);
			m_ptrJSDoc.Bind(m_ptrJSApp->CreateDoc(ptrDoc), false);
			m_ptrJSApp->AttachScripts(ptrDoc, m_ptrJSDoc);
		}

		Viewer_IViewableDocumentPtr ptrViewableDoc(ptrDoc->GetViewableDocument(), false);
		PDFXpansionControl->Viewer->Document = ptrViewableDoc;
	}
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnOpenXPS(TObject *Sender)
{
	if (OpenXPSDialog->Execute(NULL))
	{
		XPS_IPackagePtr ptrDoc(PDFXpansionControl->Application->get_Factory()->CreateXPSPackage(), false);
		ptrDoc->OpenFile(OpenXPSDialog->FileName.w_str());
		Viewer_IViewableDocumentPtr ptrViewableDoc(ptrDoc->GetViewableDocument(), false);
		PDFXpansionControl->Viewer->Document = ptrViewableDoc;
	}
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnClose(TObject *Sender)
{
	Close();
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnModeNormal(TObject *Sender)
{
	//PDFXpansionControl->Viewer->Canvas->Mode = Viewer_viewer_mode::viewer_mode_normal;
	//PDFXpansionControl->Viewer->Config->Update();
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnModeFlip(TObject *Sender)
{
	//PDFXpansionControl->Viewer->Canvas->Mode = Viewer_viewer_mode::viewer_mode_flip;
	//PDFXpansionControl->Viewer->Config->Update();
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnLayoutVertical(TObject *Sender)
{
	PDFXpansionControl->Viewer->Canvas->VerticalLayout = !PDFXpansionControl->Viewer->Canvas->VerticalLayout;
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnLayout1ColRow(TObject *Sender)
{
	PDFXpansionControl->Viewer->Canvas->LayoutMultiplicity = 1;
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnLayout2ColRow(TObject *Sender)
{
	PDFXpansionControl->Viewer->Canvas->LayoutMultiplicity = 2;
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnLayout4ColRow(TObject *Sender)
{
	PDFXpansionControl->Viewer->Canvas->LayoutMultiplicity = 4;
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnLayoutCoverPage(TObject *Sender)
{
	PDFXpansionControl->Viewer->Canvas->SeparateCover = !PDFXpansionControl->Viewer->Canvas->SeparateCover;
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnZoom50(TObject *Sender)
{
	PDFXpansionControl->Viewer->Canvas->Zoom = 0.5;
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnZoom100(TObject *Sender)
{
	PDFXpansionControl->Viewer->Canvas->Zoom = 1.0;
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnZoom200(TObject *Sender)
{
	PDFXpansionControl->Viewer->Canvas->Zoom = 2.0;
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnZoom500(TObject *Sender)
{
	PDFXpansionControl->Viewer->Canvas->Zoom = 5.0;
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnFitWidth(TObject *Sender)
{
	PDFXpansionControl->Viewer->Canvas->Fit = Viewer_viewer_fit::viewer_fit_page_width;
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnFitHeight(TObject *Sender)
{
	PDFXpansionControl->Viewer->Canvas->Fit = Viewer_viewer_fit::viewer_fit_page_height;
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnFitPage(TObject *Sender)
{
	PDFXpansionControl->Viewer->Canvas->Fit = Viewer_viewer_fit::viewer_fit_page;
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnRotateCW(TObject *Sender)
{
	PDFXpansionControl->Viewer->Canvas->Rotation = (PDFXpansionControl->Viewer->Canvas->Rotation + 90) % 360;
}

//---------------------------------------------------------------------------
void __fastcall TMainFrame::OnRotateCCW(TObject *Sender)
{
	PDFXpansionControl->Viewer->Canvas->Rotation = (PDFXpansionControl->Viewer->Canvas->Rotation + 270) % 360;
}

//---------------------------------------------------------------------------
