//---------------------------------------------------------------------------

#ifndef MainFrmH
#define MainFrmH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "PDF_Xpansion_Wrapper_13_OCX.h"
#include <Menus.hpp>
#include <Dialogs.hpp>
#include "PDF_Xpansion_ActiveX_13_OCX.h"
#include <OleCtrls.hpp>
#include "PDF_Xpansion_JS_13_TLB.h"
//---------------------------------------------------------------------------

class TMainFrame : public TForm
{
__published:	// IDE-managed Components
	TPDFXpansionControl *PDFXpansionControl;
	TMainMenu *MainMenu;
	TMenuItem *FileMenuItem;
	TMenuItem *OpenPDFMenuItem;
	TMenuItem *OpenXPSMenuItem;
	TMenuItem *N1;
	TMenuItem *CloseMenuItem;
	TMenuItem *ViewerMenuItem;
	TMenuItem *ModeMenuItem;
	TMenuItem *ModeNormalMenuItem;
	TMenuItem *ModeFlipMenuItem;
	TMenuItem *N2;
	TMenuItem *LayoutMenuItem;
	TMenuItem *LayoutVerticalMenuItem;
	TMenuItem *N3;
	TMenuItem *Layout1ColRowMenuItem;
	TMenuItem *Layout2ColRowMenuItem;
	TMenuItem *Layout4ColRowMenuItem;
	TMenuItem *N4;
	TMenuItem *LayoutCoverPageMenuItem;
	TMenuItem *N5;
	TMenuItem *ZoomFitMenuItem;
	TMenuItem *Zoom50MenuItem;
	TMenuItem *Zoom100MenuItem;
	TMenuItem *Zoom200MenuItem;
	TMenuItem *Zoom500MenuItem;
	TMenuItem *N6;
	TMenuItem *FitWidthMenuItem;
	TMenuItem *FitHeightMenuItem;
	TMenuItem *FitPageMenuItem;
	TMenuItem *N7;
	TMenuItem *RotateMenuItem;
	TMenuItem *RotateCWMenuItem;
	TMenuItem *RotateCCWMenuItem;

	TOpenDialog *OpenPDFDialog;
	TOpenDialog *OpenXPSDialog;

	void __fastcall FormDestroy(TObject *Sender);

	void __fastcall FormShow(TObject *Sender);
	void __fastcall OnOpenPDF(TObject *Sender);
	void __fastcall OnOpenXPS(TObject *Sender);
	void __fastcall OnClose(TObject *Sender);

	void __fastcall OnModeNormal(TObject *Sender);
	void __fastcall OnModeFlip(TObject *Sender);

	void __fastcall OnLayoutVertical(TObject *Sender);
	void __fastcall OnLayout1ColRow(TObject *Sender);
	void __fastcall OnLayout2ColRow(TObject *Sender);
	void __fastcall OnLayout4ColRow(TObject *Sender);
	void __fastcall OnLayoutCoverPage(TObject *Sender);

	void __fastcall OnZoom50(TObject *Sender);
	void __fastcall OnZoom100(TObject *Sender);
	void __fastcall OnZoom200(TObject *Sender);
	void __fastcall OnZoom500(TObject *Sender);

	void __fastcall OnFitWidth(TObject *Sender);
	void __fastcall OnFitHeight(TObject *Sender);
	void __fastcall OnFitPage(TObject *Sender);

	void __fastcall OnRotateCW(TObject *Sender);
	void __fastcall OnRotateCCW(TObject *Sender);

public:
	HINSTANCE m_hJSLib;	
	Pdf_xpansion_js_13_tlb::IJSToolsPtr m_ptrJSTools;
	Pdf_xpansion_js_13_tlb::IJSAppPtr m_ptrJSApp;
	Pdf_xpansion_js_13_tlb::IJSDocPtr m_ptrJSDoc;
	Pdf_xpansion_js_13_tlb::IJSEventsPtr m_ptrJSEvents;

	Pdf_xpansion_wrapper_13_tlb::Viewer_IViewerEventsPtr m_ptrEvents;

	void InitJsTools();

public:		// User declarations
	__fastcall TMainFrame(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainFrame *MainFrame;
//---------------------------------------------------------------------------
#endif
