﻿using SX.UWP;
using System;
using Windows.UI.Popups;

namespace Sample
{    
    class Tools
    {
        public static bool AuthorizeSDK()
        {
            ErrorCode errorCode = ErrorCode.ErrorNone;
            try
            {
                PDFXpansionSDK.EntryPoint().Authorize(License.Key);
            }
            catch (Exception ex)
            {
                errorCode = (ErrorCode)(ex.HResult & 0xFFFF);
            }

            if (errorCode != ErrorCode.ErrorNone)
            {
                string msg = "Unknown error, please contact PDF Xpansion team.";
                switch (errorCode)
                {
                    case ErrorCode.ErrorAuthFailed: msg = "The specified license key does not fit used license file."; break;
                    case ErrorCode.ErrorPathNotFound: msg = "Can't find PDF Xpansion license file: pdf-xpansion.license."; break;
                    case ErrorCode.ErrorAccessDenied: msg = "Can't find PDF Xpansion resources file: pdf-xpansion.pds."; break;
                    case ErrorCode.ErrorOutOfRange: msg = "The trial license is expired, please download actual version of PDF Xpansion."; break;
                }

                (new MessageDialog(msg)).ShowAsync().AsTask().ContinueWith((arg) => { Windows.UI.Xaml.Application.Current.Exit(); } );
            }

            return errorCode == ErrorCode.ErrorNone;
        }
    }
       
}
