﻿using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;

namespace Sample
{
    public delegate bool ValidatePasswordHandler(string password);

    public sealed partial class PasswordDialog : ContentDialog
    {
        private ValidatePasswordHandler m_passValidator;
        
        public PasswordDialog(ValidatePasswordHandler validator)
        {
            m_passValidator = validator;
            this.InitializeComponent();
        }

        private void OnPrimaryButtonClick(ContentDialog sender, ContentDialogButtonClickEventArgs args)
        {
            if (!m_passValidator(passBox.Password))
            {
                args.Cancel = true;
                lblWrongPass.Visibility = Visibility.Visible;
                passBox.Password = "";
                passBox.Focus(FocusState.Programmatic);
            }
            
        }
    }
}
