﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using SX.NET;
using SX.NET.PDF;
using SX.NET.Viewer;
using SX.NET.XPS;

namespace PDF_Xpansion_Reader
{
    public partial class Form1 : Form
    {
        #region Layout content
        const string HEADER_1 = " for application development that has the unprecedented potential to enable developers to build rich interactive experiences, powered by vast data stores, that are available on any device. Although the boundaries of the platform continue to evolve, industry leaders speak nearly in unison about how HTML5 will be the cornerstone for this platform. But the full strength of the platform relies on many more technologies that W3C and its partners are creating, including CSS, SVG, WOFF, the Semantic Web stack, XML, and a variety of APIs.";
        const string HEADER_2 = "W3C develops these technical specifications and guidelines through a process designed to maximize consensus about the content of a technical report, to ensure high technical and editorial quality, and to earn endorsement by W3C and the broader community.";
        string[] BODIES = 
	{	
		"Web Design and Applications involve the standards for building and Rendering Web pages, including HTML, CSS, SVG, Ajax, and other technologies for Web Applications (“WebApps”). This section also includes information on how to make pages accessible to people with disabilities (WCAG), to internationalize them, and make them work on mobile devices.",
		"W3C is focusing on technologies to enable Web access anywhere, anytime, using any device. This includes Web access from mobile phones and other mobile devices as well as use of Web technology in consumer electronics, printers, interactive television, and even automobiles.",
		"Web Architecture focuses on the foundation technologies and principles which sustain the Web, including URIs and HTTP.",
		"In addition to the classic “Web of documents” W3C is helping to build a technology stack to support a “Web of data,” the sort of data you find in databases. The ultimate goal of the Web of data is to enable computers to do more useful work and to develop systems that can support trusted interactions over the network. The term “Semantic Web” refers to W3C’s vision of the Web of linked data. Semantic Web technologies enable people to create data stores on the Web, build vocabularies, and write rules for handling data. Linked data are empowered by technologies such as RDF, SPARQL, OWL, and SKOS.",
		"XML Technologies including XML, XML Namespaces, XML Schema, XSLT, Efficient XML Interchange (EXI), and other related standards."
	};
        string[] HEADERS =
	{	
		"Web Design and Applications",
		"Web of Devices",
		"Web Architecture",
		"Semantic Web",
		"XML Technology"
	};
        string[] IMAGE_FILES =
	{
		"palette.png",
		"phone.png",
		"hammer.png",
		"box.png",
		"xml.png"
	};
        #endregion
        #region text_layout flags
        const uint text_layout_linearize = 0x01;
        const uint text_layout_wrap = 0x02;
        const uint text_layout_align = 0x04;
        const uint text_layout_clear_nl = 0x10;
        const uint text_layout_clear_marg = 0x20;
        #endregion
        #region text styles
        SX.NET.Content.ITextStyle pBlackNormal10;
        SX.NET.Content.ITextStyle pBlackBold10;
        SX.NET.Content.ITextStyle pBlueNormal10;
        SX.NET.Content.ITextStyle pBlackNormal22;
        SX.NET.Content.ITextStyle pWhiteNormal22;
        SX.NET.Content.ITextStyle pBlueNormal17;
        #endregion
        SX.NET.PDF.IDocument mainDoc;
        const uint GDI_opt_import_plus = 0x100000;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // configurate the viewer here
            sxFormsControl.Config.UseCache = false;
            sxFormsControl.Config.PageCacheSize = 50;
            sxFormsControl.Config.PageCacheInvalidation = 300;
            sxFormsControl.Config.PDF.Popups = viewer_popups.viewer_popups_single;
        }

        private void InitTextStyles(SX.NET.Content.IRichContent rc)
        {
            pBlackBold10 = rc.CreateTextStyle();
            pBlackBold10.SetFont(new SX.NET.sx_color_i_rgb(0, 0, 0), "Arial", 10, 700, false, 1);
            pBlackBold10.Leading = 15;

            pBlackNormal10 = rc.CreateTextStyle();
            pBlackNormal10.SetFont(new SX.NET.sx_color_i_rgb(0, 0, 0), "Arail", 10, 400, false, 1);
            pBlackNormal10.Leading = 15;

            pBlueNormal10 = rc.CreateTextStyle();
            pBlueNormal10.SetFont(new SX.NET.sx_color_i_rgb(0, 51, 102), "Arial", 10, 400, false, 1);
            pBlueNormal10.Leading = 15;

            pBlackNormal22 = rc.CreateTextStyle();
            pBlackNormal22.SetFont(new SX.NET.sx_color_i_rgb(0, 0, 0), "Arial", 22, 400, false, 1);
            pBlackNormal22.Leading = 15;

            pWhiteNormal22 = rc.CreateTextStyle();
            pWhiteNormal22.SetFont(new SX.NET.sx_color_i_rgb(255, 255, 255), "Arial", 22, 400, false, 1);
            pWhiteNormal22.Leading = 15;

            pBlueNormal17 = rc.CreateTextStyle();
            pBlueNormal17.SetFont(new SX.NET.sx_color_i_rgb(0, 51, 102), "Arial", 17.5, 400, false, 1);
            pBlueNormal17.Leading = 15;
        }

        private SX.NET.PDF.IPage CreatePage(SX.NET.PDF.IDocument doc, float w, float h)
        {
            SX.NET.PDF.IPage page = doc.Pages.Add();
            RectangleF rect = new RectangleF(0, 0, w, h);
            page.SetMediaBox(rect);
            return page;
        }

        private void FillPage(SX.NET.Content.IRichContent content)
        {
            // add page title
            SX.NET.Graphics.IMatrix matrix = sxFormsControl.Application.Factory.Matrix();
            RectangleF rect = new RectangleF(48, 27, 495, 50); // in points
            SX.NET.Content.IPath path = content.CreatePath();
            path.AddBox(rect, true, true);
            SX.NET.Content.IRichVector titleBack = (SX.NET.Content.IRichVector)content.Objects.Insert(content.Objects.Count, SX.NET.Content.rich_type.rich_type_vector);
            titleBack.Path = path;
            titleBack.Pen = content.CreatePen(1);
            titleBack.StrokeBrush = content.CreateSolidBrush(new SX.NET.sx_color_i_rgb(174, 194, 211));
            titleBack.FillBrush = content.CreateSolidBrush(new SX.NET.sx_color_i_rgb(219, 231, 240));
            rect.X += 20; rect.Y += 15; // text offset
            AddText(content, ref rect, "STANDARDS", pWhiteNormal22); //text shadow
            rect.X--; rect.Y--;
            AddText(content, ref rect, "STANDARDS", pBlackNormal22); // text

            // main text
            rect.Y = rect.Y + rect.Height + 20; rect.X = rect.X + 20; rect.Width = 475;
            SX.NET.Content.IRichText txtBody = AddText(content, ref rect, "W3C standards define an ", pBlackNormal10);
            txtBody = AddText(content, ref rect, "Open Web Platform", pBlackBold10 , txtBody);
            txtBody = AddText(content, ref rect, HEADER_1, pBlackNormal10, txtBody);

            RectangleF trect = new RectangleF(); SX.NET.sx_matrix mx = new sx_matrix();
            txtBody.GetTransformation(ref mx);
            txtBody.GetBBox(mx, ref trect);
            rect.Y = trect.Y + trect.Height + 20;
            txtBody = AddText(content, ref rect, HEADER_2, pBlackNormal10);

            // blocks
            txtBody.GetTransformation(ref mx);
            txtBody.GetBBox(mx, ref trect);
            rect.Y = trect.Height + trect.Y + 32;

            for (int blockIndex = 0; blockIndex < 5; blockIndex++)
            {
                rect = AddBlock(content, rect, GetFilePath(IMAGE_FILES[blockIndex]), HEADERS[blockIndex], BODIES[blockIndex]);
                rect.Y += rect.Height + 20;
            }

            // add footer 
            RectangleF pageRect = new RectangleF();
            content.GetMatrix(ref mx);
            content.GetBBox(mx,ref pageRect);
            rect.Height = rect.X = rect.Y = 0;
            rect.Width = pageRect.Width;
            SX.NET.Content.IRichText txtFooter = AddText(content, ref rect, "Copyright © 2015 W3C ® ", pBlackNormal10);
            AddText(content, ref rect, "( MIT , ERCIM , Keio, Beihang) Usage policies apply.", pBlueNormal10, txtFooter);
            matrix.Identity(ref mx);
            txtFooter.GetBBox(mx, ref trect);
            matrix.Translate(ref mx, (pageRect.Width - trect.Width) / 2, pageRect.Height  - 20, false);
            txtFooter.ApplyTransformation(mx);
        }

        private void mnuCreate_Click(object sender, EventArgs e)
        {
            // create new document and page
            mainDoc = sxFormsControl.Application.Factory.CreatePDFDocument();
            // add new empty page
            SX.NET.PDF.IPage page = CreatePage(mainDoc, 595.276f, 841.89f);
            // layout content
            SX.NET.Content.IRichContent content = page.GetRichContent(0);
            InitTextStyles(content);
            FillPage(content);
            // load doc in viewer
            sxFormsControl.Document = mainDoc.GetViewableDocument();
        }

        private void ShowErrorMessage(SX.NET.ErrorCode err)
        {
            string mess = string.Empty;
            switch (err)
            {
                case SX.NET.ErrorCode.ErrorOutOfMemory: mess = "not enough memory"; break;
                case SX.NET.ErrorCode.ErrorOutOfSpace: mess = "not enough disk space"; break;
                case SX.NET.ErrorCode.ErrorOutOfRange: mess = "index out of range"; break;
                case SX.NET.ErrorCode.ErrorInvalidFormat: mess = "invalid data format"; break;
                case SX.NET.ErrorCode.ErrorInvalidUse: mess = "invalid using"; break;
                case SX.NET.ErrorCode.ErrorInvalidParam: mess = "invalid argument"; break;
                default: mess = "Unknown error, please contact PDF Xpansion team."; break;
            }

            MessageBox.Show(mess, "ERROR", MessageBoxButtons.OK, MessageBoxIcon.Error);
        }

        private SX.NET.Content.IRichObject AddRectangle(SX.NET.Content.IRichContent rc, ref RectangleF rect, SX.NET.sx_color fillColor, SX.NET.sx_color strokeColor)
        {
            SX.NET.Content.ISolidBrush fillBrush = rc.CreateSolidBrush(fillColor);
            SX.NET.Content.ISolidBrush strokeBrush = rc.CreateSolidBrush(strokeColor);
            SX.NET.Content.IPen strokePen = rc.CreatePen(1);
            SX.NET.Content.IPath path = rc.CreatePath();

            path.AddBox(rect, true, true);

            SX.NET.Content.IRichVector vector = (SX.NET.Content.IRichVector)rc.Objects.Insert(rc.Objects.Count, SX.NET.Content.rich_type.rich_type_vector);
            vector.Pen = strokePen;
            vector.FillBrush = fillBrush;
            vector.StrokeBrush = strokeBrush;
            vector.Path = path;

            return vector;
        }

        private SX.NET.Content.IRichText AddText(SX.NET.Content.IRichContent rc, ref RectangleF rect, string text, SX.NET.Content.ITextStyle textStyle, SX.NET.Content.IRichText richText = null)
        {
            SX.NET.Content.IRichText txt = richText;
            if (txt == null)
                txt = (SX.NET.Content.IRichText)rc.Objects.Insert(rc.Objects.Count, SX.NET.Content.rich_type.rich_type_text);

            txt.InsertChars(txt.Length, text, textStyle);
            txt.Relayout(rect.Width, text_layout_wrap, SX.NET.Content.text_alignment.text_alignment_left);

            if (richText != null)
                return txt;

            // transform text area to PDF space
            SX.NET.sx_matrix textMatr = new SX.NET.sx_matrix();
            RectangleF textRect = new RectangleF();

            SX.NET.Graphics.IMatrix matrix = sxFormsControl.Application.Factory.Matrix();
            matrix.Identity(ref textMatr);
            txt.GetBBox(textMatr, ref textRect);
            matrix.Translate(ref textMatr, rect.X, rect.Y + textRect.Height + textRect.Y, false);
            txt.ApplyTransformation(textMatr);
            return txt;
        }

        private SX.NET.Content.IRichObject AddImage(SX.NET.Content.IRichContent rc, string imagePath, RectangleF rect)
        {
            SX.NET.Graphics.IBitmapData bmp = sxFormsControl.Application.Factory.CreateBitmapFromStream(sxFormsControl.Application.Factory.CreateReadStream(imagePath));
            SX.NET.Content.IRichRaster raster = (SX.NET.Content.IRichRaster)rc.Objects.Insert(rc.Objects.Count, SX.NET.Content.rich_type.rich_type_raster);
            raster.Bitmap = bmp;

            SX.NET.Graphics.IMatrix matrix = sxFormsControl.Application.Factory.Matrix();
            SX.NET.sx_matrix matr = new SX.NET.sx_matrix();
            RectangleF imgRect = new RectangleF();
            matrix.Identity(ref matr);
            raster.GetBBox(matr, ref imgRect);
            matrix.Translate(ref matr, rect.X, rect.Y, false);
            matrix.Scale(ref matr, 72 / bmp.DPI, 72 / bmp.DPI, false);
            raster.ApplyTransformation(matr);
            return raster;
        }

        private RectangleF AddBlock(SX.NET.Content.IRichContent rc, RectangleF rect, string imagePath, string Header, string Body)
        {
            RectangleF resRect = new RectangleF(rect.X, rect.Y, rect.Width, 0);
            // main image
            AddImage(rc, imagePath, rect);
            // header
            rect.X += 60;
            SX.NET.Content.IRichText text = AddText(rc, ref rect, Header, pBlueNormal17);
            // body text
            SX.NET.Graphics.IMatrix matrix = sxFormsControl.Application.Factory.Matrix();
            SX.NET.sx_matrix mx = new sx_matrix();
            text.GetMatrix(ref mx);
            RectangleF mrect = new RectangleF();
            text.GetBBox(mx, ref mrect);
            mrect.Width = rect.Width - 64;
            mrect.Y = rect.Y + mrect.Height + 4;
            text = AddText(rc, ref mrect, Body, pBlackNormal10);
            text.GetTransformation(ref mx);
            text.GetBBox(mx, ref mrect);
            resRect.Height = mrect.Y + mrect.Height - resRect.Y;
            return resRect;
        }

        string GetFilePath(string fileName)
        {
            return System.IO.Directory.GetParent(System.IO.Directory.GetParent(Application.StartupPath).FullName) + "\\" + fileName;
        }

        private void fileToolStripMenuItem_DropDownOpening(object sender, EventArgs e)
        {
            mnuSave.Enabled = mainDoc != null;
        }

        private void mnuSave_Click(object sender, EventArgs e)
        {
            SaveFileDialog dlg = new SaveFileDialog();
            dlg.Filter = "PDF documents (*.pdf)|*.pdf";
            if (dlg.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                try
                {
                    mainDoc.SaveAsFile(dlg.FileName);
                }
                catch (SX.NET.Exception ex)
                {
                    ShowErrorMessage(ex.get_ErrorCode());
                }
                catch (System.Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }
        }

        private void mnuCreateEMF_Click(object sender, EventArgs e)
        {
            mainDoc = sxFormsControl.Application.Factory.CreatePDFDocument();
            SX.NET.sx_matrix matr = new sx_matrix();
            sxFormsControl.Application.Factory.Matrix().Identity(ref matr);
            GDI2PDF gdi2pdf = new GDI2PDF(sxFormsControl.Application.Factory);
            for (uint ind = 0; ind < 3; ind++)
            {
                SX.NET.PDF.IPage page = mainDoc.Pages.Add();
                ISequentialStream stream = gdi2pdf.DrawPage(ind);
                ICompositeImage emfImage = mainDoc.Resources.AddGdiMetafile(stream, 0, GDI_opt_import_plus);
                mainDoc.Pages.Item(ind).InsertImage(emfImage, matr, false);
            }
            sxFormsControl.Document = mainDoc.GetViewableDocument();
        }
    }
}
