﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
using System.IO;
using System.Drawing;

namespace PDF_Xpansion_Reader
{
    class GDI2PDF
    {
        [DllImport("user32.dll", EntryPoint = "GetDC")]
        public static extern IntPtr GetDC(IntPtr ptr);

        [DllImport("user32.dll", EntryPoint = "ReleaseDC")]
        public static extern bool ReleaseDC(IntPtr hWnd, IntPtr hDC);

        [DllImport("gdi32")]
        public static extern int GetEnhMetaFileBits(int hemf, int cbBuffer, byte[] lpbBuffer);

        [DllImport("gdi32")]
        public static extern bool DeleteEnhMetaFile(int hemf);

        SX.NET.IAppFactory factory;

        public GDI2PDF(SX.NET.IAppFactory fact)
        {
            factory = fact;
        }

        public SX.NET.ISequentialStream DrawPage(uint ind)
        {
            IntPtr hdc = GetDC(IntPtr.Zero);
            RectangleF pageRect = new RectangleF(0, 0, 595.3f, 841.9f);
            System.Drawing.Imaging.Metafile metafile = new System.Drawing.Imaging.Metafile(hdc, pageRect, System.Drawing.Imaging.MetafileFrameUnit.Point, System.Drawing.Imaging.EmfType.EmfPlusOnly);
            ReleaseDC(IntPtr.Zero, hdc);
            // draw page to metafile graphics
            Font font = new Font("Time New Roman", 24, FontStyle.Regular);
            using (Graphics g = Graphics.FromImage(metafile))
            {
                string sPageNum = string.Format("Page: {0}", ind + 1);
                SizeF sSize = g.MeasureString(sPageNum, font);
                g.DrawString(sPageNum, font, Brushes.Black, new PointF(pageRect.Width - sSize.Width, 0));
            }
            // get metafile data
            int hMetafile = metafile.GetHenhmetafile().ToInt32();
            int sz = GetEnhMetaFileBits(hMetafile, 0, null);
            byte[] buffer = new byte[sz];
            GetEnhMetaFileBits(hMetafile, sz, buffer);
            DeleteEnhMetaFile(hMetafile);
            // copy metafile data to stream
            MemoryStream ms = new MemoryStream(); ms.Write(buffer, 0, sz);
            SX.NET.ISequentialStream stream = factory.CreateRefStream(ms);
            stream.Reset();
            return stream;
        }
    }
}
