﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace PDF_Xpansion_Reader
{
    public partial class frmAddNewOutline : Form
    {
        private uint m_PageCount;
        public frmAddNewOutline(uint PageCount)
        {
            InitializeComponent();
            m_PageCount = PageCount;
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.Close();
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            if (CheckVal())
            {
                DialogResult = System.Windows.Forms.DialogResult.OK;
                this.Close();
            }
        }

        private bool CheckVal()
        {
            int page;
            if (!int.TryParse(txtPageNum.Text, out page))
            {
                MessageBox.Show("Incorrect page number", string.Empty, MessageBoxButtons.OK);
                return false;
            }

            page--;
            if (page < 0 || page > m_PageCount)
            {
                MessageBox.Show("Page number should be less than page count and greater than zero!", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return false;
            }

            if (string.IsNullOrWhiteSpace(txtTitle.Text))
            {
                MessageBox.Show("Title cannot be empty!", "Error", MessageBoxButtons.OK);
                return false;
            }
            return true;
        }

        public uint PageNumber { get { return uint.Parse(txtPageNum.Text) + 1; } }
        public string Title { get { return txtTitle.Text; } }
    }
}
