﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;
using SX.NET;

namespace PDF_Xpansion_Reader
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            try
            {
                IApplication appl = PDFXpansionSDK.EntryPoint();
                appl.Authorize(License.LicenseKey, "");
                Application.EnableVisualStyles();
                Application.SetCompatibleTextRenderingDefault(false);
                Application.Run(new Form1());
            }
             catch (SX.NET.Exception ex)
            {
                string sErrMessage = string.Empty;
                switch (ex.get_ErrorCode())
                {
                    case ErrorCode.ErrorAuthFailed:     sErrMessage = "The specified license key does not fit used license file"; break;
                    case ErrorCode.ErrorPathNotFound:   sErrMessage = "Can't find PDF Xpansion license file: pdf-xpansion.license"; break;
                    case ErrorCode.ErrorAccessDenied:   sErrMessage = "Can't find PDF Xpansion resources file: pdf-xpansion.pds"; break;
                    case ErrorCode.ErrorOutOfRange:     sErrMessage = "The trial license is expired, please download actual version of PDF Xpansion."; break;
                    case ErrorCode.ErrorInvalidUse:     sErrMessage = "Can't find main PDF Xpansion library file: pdf-xpansion-windesktop-xXX.dll"; break;
                    default:                            sErrMessage = "Unknown error, please contact PDF Xpansion team."; break;
                }

                MessageBox.Show(sErrMessage, "Error", MessageBoxButtons.OK, MessageBoxIcon.Stop);
            }
        }
    }
}
