﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace PDF_Xpansion_Reader
{
    public partial class SecurityDialog : Form
    {
        public SecurityDialog(SX.NET.PDF.encryption_algorithm alg, SX.NET.PDF.encryption_key_length keyLen)
        {
            InitializeComponent();

            cbbAlgorithm.Items.Add(new GenericCbbItem<SX.NET.PDF.encryption_algorithm>("AES", SX.NET.PDF.encryption_algorithm.encryption_algorithm_aes));
            cbbAlgorithm.Items.Add(new GenericCbbItem<SX.NET.PDF.encryption_algorithm>("RC4", SX.NET.PDF.encryption_algorithm.encryption_algorithm_rc4));
            cbbAlgorithm.SelectedItem = cbbAlgorithm.Items.Cast<GenericCbbItem<SX.NET.PDF.encryption_algorithm>>().FirstOrDefault(f => f.Value == alg);

            cbbKeyLength.Items.Add(new GenericCbbItem<SX.NET.PDF.encryption_key_length>("40", SX.NET.PDF.encryption_key_length.encryption_key_length_40));
            cbbKeyLength.Items.Add(new GenericCbbItem<SX.NET.PDF.encryption_key_length>("128", SX.NET.PDF.encryption_key_length.encryption_key_length_128));
            cbbKeyLength.Items.Add(new GenericCbbItem<SX.NET.PDF.encryption_key_length>("256", SX.NET.PDF.encryption_key_length.encryption_key_length_256));
            cbbKeyLength.Items.Add(new GenericCbbItem<SX.NET.PDF.encryption_key_length>("384", SX.NET.PDF.encryption_key_length.encryption_key_length_384));
            cbbKeyLength.Items.Add(new GenericCbbItem<SX.NET.PDF.encryption_key_length>("512", SX.NET.PDF.encryption_key_length.encryption_key_length_512));
            cbbKeyLength.SelectedItem = cbbKeyLength.Items.Cast<GenericCbbItem<SX.NET.PDF.encryption_key_length>>().FirstOrDefault(f => f.Value == keyLen);

            if (cbbAlgorithm.SelectedItem == null || cbbKeyLength.SelectedItem == null)
                btnOK.Enabled = false;
        }

        public string UserPassword { get { return txtUserPassword.Text; } }
        public string OwnderPassword { get { return txtOwnerPassword.Text; } }
        public SX.NET.PDF.encryption_algorithm Algorithm { get { return (cbbAlgorithm.SelectedItem as GenericCbbItem<SX.NET.PDF.encryption_algorithm>).Value; } }
        public SX.NET.PDF.encryption_key_length KeyLength { get { return (cbbKeyLength.SelectedItem as GenericCbbItem<SX.NET.PDF.encryption_key_length>).Value; } }

        private void SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cbbAlgorithm.SelectedItem == null || cbbKeyLength.SelectedItem == null)
                return;

            int keyLen = (int)(cbbKeyLength.SelectedItem as GenericCbbItem<SX.NET.PDF.encryption_key_length>).Value;
            if (((cbbAlgorithm.SelectedItem as GenericCbbItem<SX.NET.PDF.encryption_algorithm>).Value == SX.NET.PDF.encryption_algorithm.encryption_algorithm_rc4 && keyLen > 128) || ((cbbAlgorithm.SelectedItem as GenericCbbItem<SX.NET.PDF.encryption_algorithm>).Value == SX.NET.PDF.encryption_algorithm.encryption_algorithm_aes && keyLen < 128))
            {
                MessageBox.Show("The current key length is not compatible with the selected algorithm", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                btnOK.Enabled = false;
            }
            else
            {
                btnOK.Enabled = true;
            }
        }

    }
}
