﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using SX.NET;
using SX.NET.Viewer;

namespace PDF_Xpansion_Reader
{
    public partial class FindForm : Form, ISearchStatus
    {
        ISearchProvider SearchProvider;
        IViewerCanvas ViewerCanvas;
        const string TextNotFound = "Text not found!";
        public FindForm(ISearchProvider searchProvider, IViewerCanvas viewerCanvas)
        {
            InitializeComponent();
            SearchProvider = searchProvider;
            ViewerCanvas = viewerCanvas;
        }

        private void PrepareSearchProvider()
        {
            //Reset search declarations
            if (SearchProvider.Text != txtSearch.Text)
                SearchProvider.Reset(txtSearch.Text, ViewerCanvas.ActivePage, 0);
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            DialogResult = System.Windows.Forms.DialogResult.Cancel;
            ViewerCanvas.ResetMarking(null, 0);
            this.Close();
        }

        private void btnNext_Click(object sender, EventArgs e)
        {
            PrepareSearchProvider();
            if (SearchProvider.SearchForward(this))
                ViewerCanvas.Navigate(SearchProvider);
            else
                MessageBox.Show(TextNotFound);
        }

        public bool OnPage(uint ind, uint count)
        {
            //Display some status info here
            lblMessage.Text = string.Format("Text found on {0} of {1}", ind+1, count);
            return true;
        }

        private void btnPrev_Click(object sender, EventArgs e)
        {
            PrepareSearchProvider();
            if (SearchProvider.SearchBack(this))
                ViewerCanvas.Navigate(SearchProvider);
            else
                MessageBox.Show(TextNotFound);
        }
    }
}
