﻿Public Class Form1

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs)
        sxFormsControl.Config.UseCache = False
        sxFormsControl.Config.PageCacheSize = 50
        sxFormsControl.Config.PageCacheInvalidation = 300
        sxFormsControl.Config.PDF.Popups = SX.NET.Viewer.viewer_popups.viewer_popups_single
    End Sub

    Private Function CheckSecurity(ByVal pDocSecurity As SX.NET.PDF.IDocSecurity) As Boolean
        Dim dSec As SX.NET.PDF.doc_security = pDocSecurity.Security
        If dSec = SX.NET.PDF.doc_security.doc_security_none Then Return True

        If dSec = SX.NET.PDF.doc_security.doc_security_password Then
            Dim pPassSec As SX.NET.PDF.IPasswordSecurity = CType(pDocSecurity.StandardSecurity, SX.NET.PDF.IPasswordSecurity)
            If pPassSec.SetUserPassword(String.Empty) Then Return True
            Dim bInvalidPassword As Boolean = True

            Do
                Dim passwordDialog As PasswordDlg = New PasswordDlg()
                If passwordDialog.ShowDialog() = System.Windows.Forms.DialogResult.Cancel Then Return False
                Dim sPasswrd As String = passwordDialog.PasswordString
                bInvalidPassword = Not (pPassSec.SetUserPassword(sPasswrd) OrElse pPassSec.SetOwnerPassword(sPasswrd))
                If bInvalidPassword Then MessageBox.Show("Entered password is invalid", "", MessageBoxButtons.OK, MessageBoxIcon.Stop)
            Loop While bInvalidPassword
        End If

        Return True
    End Function

    Private Sub openToolStripMenuItem_Click(sender As System.Object, e As System.EventArgs) Handles openToolStripMenuItem.Click
            Dim dlg As OpenFileDialog = New OpenFileDialog()
            dlg.DefaultExt = ".pdf"
            dlg.Filter = "PDF documents |*.pdf"
            dlg.RestoreDirectory = True

            If dlg.ShowDialog() = DialogResult.OK Then
                Dim doc As SX.NET.PDF.IDocument = sxFormsControl.Application.Factory.CreatePDFDocument()
                doc.OpenFile(dlg.FileName, 0)
                If Not CheckSecurity(doc.Properties.Security) Then Return
                sxFormsControl.Document = doc.GetViewableDocument()
            End If
    End Sub

    Private Sub openXPSToolStripMenuItem_Click(sender As System.Object, e As System.EventArgs) Handles openXPSToolStripMenuItem.Click
            Dim dlg As OpenFileDialog = New OpenFileDialog()
            dlg.DefaultExt = ".xps"
            dlg.Filter = "XPS documents |*.xps"

            If dlg.ShowDialog() = DialogResult.OK Then
                Dim appl As SX.NET.IApplication = SX.NET.PDFXpansionSDK.EntryPoint()
                Dim xpsPack As SX.NET.XPS.IPackage = appl.Factory.CreateXPSPackage()
                xpsPack.OpenFile(dlg.FileName)
                sxFormsControl.Document = xpsPack.GetViewableDocument()
            End If
    End Sub
End Class
