﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Windows;
using SX.NET;

namespace WPF_reader
{
    /// <summary>
    /// Interaction logic for App.xaml
    /// </summary>
    public partial class App : Application
    {
        protected override void OnStartup(StartupEventArgs e)
        {
            base.OnStartup(e);
            try
            {
                IApplication appl = PDFXpansionSDK.EntryPoint();
                appl.Authorize(License.LicenseKey, "");

            }
            catch (SX.NET.Exception ex)
            {
                string sErrMessage = string.Empty;
                switch (ex.get_ErrorCode())
                {
                    case ErrorCode.ErrorAuthFailed: sErrMessage = "The specified license key does not fit used license file"; break;
                    case ErrorCode.ErrorPathNotFound: sErrMessage = "Can't find PDF Xpansion license file: pdf-xpansion.license"; break;
                    case ErrorCode.ErrorAccessDenied: sErrMessage = "Can't find PDF Xpansion resources file: pdf-xpansion.pds"; break;
                    case ErrorCode.ErrorOutOfRange: sErrMessage = "The trial license is expired, please download actual version of PDF Xpansion."; break;
                    default: sErrMessage = "Unknown error, please contact PDF Xpansion team."; break;
                }

                MessageBox.Show(sErrMessage, "ERROR", MessageBoxButton.OK, MessageBoxImage.Stop);

            }
            catch (System.Exception ex)
            {
                MessageBox.Show("Unknown error, please contact PDF Xpansion team." + Environment.NewLine
                                + "System info: " + ex.Message);
            }            
        }       
    }
}
